/* --------------------------------------------------------------
     ᫠  ࠭祭 ࠧ來 ⪮.
    㦥 㭪樨  設-ᨬ ਠ.

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2003, ..஢,   PAH.
    All Rights Reserved.

     ।⠢  ᫮ 業 "public domain",
    .. ᪠ ᢮ ਬ, 䨪 
    ࠭   ᫮ ࠭ ࠩ
      ᢥ   ᥭ .

           .
        "AS IS"  - 
         .
-------------------------------------------------------------- */
#include <ctype.h>
#include <stdlib.h>
#include <iomanip.h>
#include <limits.h>
#include "Cbignum.h"
#include <assert.h>
#define BITS            (CHAR_BIT * sizeof (long))

//================================================
//      ன ⮬᪮ ⨬樨.
//================================================
//      SHIFT_TAB_MIN    ࠧ ⥫  ,
//                       ஬  ந ⠡ ᤢ
//                        ⥫
//
//      SHIFT_TAB_OPT   ⨬ ࠧ 窠 
//                       筮 㬭  ᤢ;
//                       ᥣ  ᫮ 8n - 3.
//
//      SHIFT_TAB_HIGH  ᨬ ࠧ 窠 
//                       筮 㬭  ᤢ.
//
//      SHIFT_TAB_MAX   ᨬ ࠧ ⥫,  ஬
//                       ந ⠡ ᤢ .

#define SHIFT_TAB_MIN   (3)
#define SHIFT_TAB_OPT   ((sizeof(size_t))==2? 15-3: 480-3)
#define SHIFT_TAB_HIGH  (SHIFT_TAB_OPT + SHIFT_TAB_OPT / 2)
#define SHIFT_TAB_MAX   (EXSIZE_T_MAX / (1024 * sizeof (long)))

//================================================
//      㦥 㭪樨.
//================================================

inline size_t size_max (size_t n1, size_t n2)
{
  return ((n1 > n2)? n1 : n2);
}
inline size_t size_min (size_t n1, size_t n2)
{
  return ((n1 < n2)? n1 : n2);
}

#ifdef  __cplusplus
extern "C" {
#endif//__cplusplus

//================================================
//       権  ᫠ cBigNumber.
//================================================
//       楫 ᫮ ࠭  ᨢ ⨯ long.
//       ᨢ  㫥 ᮬ ᮤন ᫮ long-᫮,
//      ॡ㥬  ।⠢  ᫠  ⥫쭮
//      筮 ,  ᫥  - ᠬ  ᫠,
//       浪   ࠧ冷  訬.
//       ᫠ 室  ᫥ ᫮.
//
//      樨 ॠ   㭪権 몠 C.
//       ᫠ । १ யࠬ EXPTR(long):
//       long *  ࠡ祬 ०  exptr<long>  ⫠筮
//      ०  ஢મ 室   ࠭ ᨢ.
//      室 ᫠   䨪஬ const.
//       㭪樨  ᮮࠦ ⨬樨  
//       ᫠ ᫮  १饬 ᫥;  ⮣
//      ᫮ ᫮ 뤠  ⢥ 祭 ⨯ size_t.
//       ⠪ 㭪権 稭   ન;
//       ᮯ஢ ᮬ, 뢠騬 㭪 
//      騬  ᫠ ᫮.
//
//      ᪨ ஫ 室 
//      ࠢ ᫥騬 ᠬ:
//      NDEBUG    - ⪫砥 ஫ 室 㪠⥫
//                   ࠭ ᨢ  ஫ 訡
//                   室 ࠬ 㭪権.
//                  室 㪠⥫  ࠭ ᨢ
//      NCHECKPTR - ⪫砥 ஫ 室 㪠⥫
//                   ࠭ ᨢ.
//
//        㭪 cBigNumber... ⨬஢
//       ⥬, ⮡ ᮪ ᫮ ஢ப  室
//       ࠡ⪥ ᫮ ᥫ.
//      冷 믮 権 ࠭, 室
//       ᮮࠦ ⨬쭮 㧪 ஢
//       Pentium.

//================================================
//      ଠ樮 㭪樨.
//================================================

//      뢮 ७ ।⠢ 믮  ⮪
//      cout  浪   ᫮  訬.  ᫮
//      । ஡  뢮  ⭠筮
//      ।⠢,  浪   ࠧ冷  訬.
//      뢮 ᫮ 蠥 ॢ ப.

void    cBigNumberDump (                        // ⫠筠 ᯥ⪠.
                const   EXPTR(long) p1,         //  ᫮.
                ostream& stream                 // ⮪.
        )
{
  char fill  = stream.fill  ('0');              // ⥫.
  long flags = stream.flags (ios::hex);         // ⭠ 뢮.

  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  for (; n1; n1--) stream <<" "<< setw(8) << (unsigned long) p1 [n1];
  stream << endl;

  stream.fill  (fill);                          // ०  ⥫.
  stream.flags (flags);                         // ० 䫠.
}

void    cBigNumberERange (                      // 饭  ९.
                const   EXPTR(long) p1          //  ᫮.
)
{
  cerr <<"cBigNumber value is out of range:";
  cBigNumberDump (p1, cerr);                    // .
  abort();                                      // 室.
}

//        ⥫쭮  ᯮ 쭮
//       ᫮ long-᫮,     ᫮:
//      - ᫨ ᫮ ᫮  1,  襥 ᫮ ⫨砥 
//        १ ७ 襣  ।᫥ ᫮;
//      -  ।⠢  㫥 ᫮.
//       ।⠢  㤥 뢠 ଠ.

int     cBigNumberIsFit (                       // ஢ઠ ଠ.
                const   EXPTR(long) p1          //  ᫮.
        )                                       // ᫨ ᫮ ଠ,
{                                               //  뤠 1  0.
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  if (n1)
  {
    if (n1 > 1) return ((p1 [n1] != (p1 [n1-1] >> (BITS-1))));
  }
  return (n1);                                  // ᫮ ᫮ 0.
}

//       業 ࠧ來 ᫠ । ᫮  .
//      騬 ⠥ ᠬ 訩 , ⫨  
//      ࠧ鸞   訥  ⭮襭   .
//      ਬ,  0  -1   , 1  -2  1 騩 ,
//      ᫠ 127  -128  7  .
//       ᫠  n 騬 ⠬  ॢ室 2  ⥯ n.
//        ਠ 㭪樨:     ᥫ.

int     cBigNumberBits (                        // ᫮  .
                const   EXPTR(long) p1          //  ᫮.
        )       // ᫮  n ⢥砥 ᫮ pow(2,n) >= abs(p1).
                // ᫨ ᫮   INT_MAX,  뤠 INT_MAX.
{
  size_t n1 = (int)(*p1);                       // ᫮ ᫮.
  if (n1)
  {
    long sign = p1 [n1];                        // .
    do
    {
      unsigned long num = p1 [n1];              // 饥 ᫮.
      if (sign < 0) num = ~num;                 // ⥫쭮 ᫮.
      if (num)                                  //  騥 ?
      {
        if (n1 <= (INT_MAX / BITS))
        {
          n1 *= BITS;                           // ᫮   ᫮.
          if (num < (1L<<(BITS/2)))             //  1- 饣 .
          {
            n1 -= BITS; do ++n1; while ((num >>= 1) > 0);
          }
          else if ((long)num > 0)
          {
            do --n1; while ((long)(num <<= 1) > 0);
          }
        }
        else n1 = INT_MAX;                      // ९.
        break;                                  //  横.
      }
    }
    while (--n1 != 0);
  }
  return (n1);
}

//      ਠ   ᥫ.

int     cLongBits (long num)                    // ᫮  .
{
  int n1 = BITS;
  if (num < 0) num = ~num;                      // ⥫쭮 ᫮.
  if (num >= (1L<<(BITS/2)))                    //  ⮢  ᫮.
  {
    do --n1; while ((num <<= 1) > 0);
  }
  else
  {
    n1 -= BITS; if (num) do ++n1; while ((num >>= 1) > 0);
  }
  return (n1);
}

//       ᫠  㫥 ᫮  ਬ
//       㡮 業 筮 浪 ᫠.

size_t  cBigNumberExpWords (                    //   0-᫮.
                const   EXPTR(long) p1          //    ᫮.
)
{
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮ p1.
  size_t n = 0;                                 // ᫮ 0-᫮ p1.
  for (; n != n1; n++)
  {
    if (p1 [n + 1] == 0) break;                 // 諨 㫥 ᫮.
  }
  return (n);
}

//================================================
//      㭪樨 ࠢ.
//================================================

//       ࠢ  ᥫ   ࠧ 
//      ⠪, ⮡  ᫠ ᮤঠ max(n1,n2) ᫮.
//      祭 ᫮ ࠢ ᫮  浪 
//       ᫮  訬  ࢮ ᮢ.
//      ࠢ  ᫮ - , ࠢ
//      ⠫ ᫮ - .

//       楫 ⨬樨  䠪᪮ ७
//       ࠧ鸞 ਬ ⬨᪨ .

int     cBigNumberComp  (                       // ࠢ p1, p2.
                const   EXPTR(long) p1,         // ᫮.
                const   EXPTR(long) p2          // ᫮.
        )                                       // 뤠 -1  p1 <  p2
                                                // 뤠  0  p1 == p2
                                                // 뤠  1  p1  > p2
{                                               // p1, p2  ᮢ.
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮  p1.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮  p2.
  register long lp1 = 0;                        // 饥 ᫮ p1.
  register long lp2 = 0;                        // 饥 ᫮ p2.

//      ࠢ  ᫮.

  if (n1) lp1 = p1 [n1--];                      //  ᫮ p1.
  if (n2) lp2 = p2 [n2--];                      //  ᫮ p2.

  if (n1 == n2)                                 //  p1, p2 ᮢ.
  {
    if (lp1 != lp2) goto NotSameSignWord;       //  ᫮  ᮢ.
  }
  else if (n1 > n2)                             // ᫨ ᫮ p1 , 
  {                                             // ஢ ࠢ 
    lp2 >>= (BITS-1); ++n2;                     // ७  p2.
    if (lp1 != lp2) goto NotSameSignWord;       //  ᫮  ᮢ.
    if (n1 > n2)                                // ࠢ  ᫮.
    {
      do                                        //  ࠢ.
      {
        lp1 = p1 [n1]; --n1;                    // ⥭ ᫮.
        if (lp1 != lp2) goto NotSame;           //   ᮢ.
      }
      while (n1 > n2);                          //  横 ࠢ.
    }
  }
  else // (n1 < n2)                             // ᫨ ᫮ p2 , 
  {                                             // ஢ ࠢ 
    lp1 >>= (BITS-1); ++n1;                     // ७  p1.
    if (lp1 != lp2) goto NotSameSignWord;       //  ᫮  ᮢ.
    if (n1 < n2)                                // ࠢ  ᫮.
    {
      do                                        //  ࠢ.
      {
        lp2 = p2 [n2]; --n2;                    // ⥭ ᫮.
        if (lp1 != lp2) goto NotSame;           //   ᮢ.
      }
      while (n1 < n2);                          //  横 ࠢ.
    }
  }

//      ୮ ࠢ  ᫮.

  if (n1)
  {
    do                                          //  ࠢ.
    {
      lp1 = p1 [n1]; lp2 = p2 [n1]; --n1;       // ⥭ ᫮.
      if (lp1 != lp2) goto NotSame;             //   ᮢ.
    }
    while (n1);                                 //  横 ࠢ.
  }

  return (0);                                   // 祭 ᮢ.
NotSame:                                        // 祭  ᮢ.
  return (((unsigned long)lp1 >= (unsigned long)lp2) * 2 - 1);
NotSameSignWord:                                //  ᮢ  ᫮.
  return ((lp1 >= lp2) * 2 - 1);
}

//================================================
//      樠஢ 㭪樨 ࠢ.
//================================================

//      ࠢ  .
//      ।, :
//      - ᫠ ଠ.
//      - ࠧ ࢮ ᫠   ࠧ ண ᫠.
//      । cࠢ ஥ ᫮ ᤢ   ᮢ ࠧ஢.

int     cBigNumberCompHigh (                    // ࠢ   ᫮.
                const   EXPTR(long) p1,         // ᫮.
                const   EXPTR(long) p2          // ᫮.
        )                                       // 뤠 -1  p1 <  p2
                                                // 뤠  0  p1 == p2
                                                // 뤠  1  p1  > p2
{                                               // p1, p2  ᮢ.
  assert (cBigNumberIsFit(p1));                 // ஢ઠ ଠ.
  assert (cBigNumberIsFit(p2));                 // ஢ઠ ଠ.
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮  p1.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮  p2.
  assert (n1 >= n2);                            // ஢ઠ ࠧ.
  assert (n2 > 0);                              // ஢ઠ ࠧ.

//      ࠢ  ᫮.

  register long lp1 = p1 [n1--];                // 饥 ᫮ p1.
  register long lp2 = p2 [n2--];                // 饥 ᫮ p2.
  if (lp1 != lp2) return ((lp1 >= lp2) * 2 - 1);//   ᮢ.

//      ୮ ࠢ  ᫮.

  if (n2)
  do                                            //  ࠢ.
  {
    lp1 = p1 [n1--]; lp2 = p2 [n2--];           // ⥭ ᫮.
    if (lp1 != lp2)                             //   ᮢ.
      return (((unsigned long)lp1 >= (unsigned long)lp2) * 2 - 1);
  }
  while (n2);                                   //  横 ࠢ.

//      ࠢ   ७.

  if (n1)
  do
  {
    if (p1 [n1--] != 0) return 1;               // ᮢ.
  }
  while (n1);

  return (0);                                   // 祭 ᮢ.
}

//      ࠢ c 0.
//       ⨬஢  ᪫祭 ᫮ 室.
//       ࠡ⠥ ⮫쪮  ଠ ᥫ.
//      뤠 ⮢ 㬬  ᫮  ᫮ ᫮,
//        2 (  ⥫쭮 ᫠ 
//      ᫮   㫥,  ⮣ ᫮ ᫮ > 1).

inline  long    cBigNumberNot0  (               // ࠢ  0:
                const EXPTR(long) p1            // 뤠 0  p1 == 0
                )                               //  ⫨筮  0.
{
  assert (cBigNumberIsFit(p1));                 // ஢ઠ ଠ.
  size_t n1 = (size_t)(*p1);
  return (p1 [n1] | (long)(n1 >> 1));
}


//================================================
//      㭪樨 ஢  ⮢ ᨨ.
//================================================

void    cBigNumberCopy (                        // ஢ p = p1.
                const   EXPTR(long) p1,         // 㥬 ᫮.
                        EXPTR(long) p           //  ࠧ *p1 + 1.
        )                                       // p1, p  ᮢ.
{
  size_t n1 = (size_t)(*p++ = *p1++);           // ᫮ ᫮.
  if (n1)
  do                                            //  ஢ ᫮.
    { *p++ = *p1++; }                           // ஢ ᫮.
  while (--n1 != 0);                            //  横 ஢.
}

void    cBigNumberCompl (                       //  p = ~p1.
                const   EXPTR(long) p1,         // 㥬 ᫮.
                        EXPTR(long) p           //  ࠧ *p1 + 1.
        )                                       // p1, p  ᮢ.
{
  size_t n1 = (size_t)(*p++ = *p1++);           // ᫮ ᫮.
  if (n1)
  do                                            //  ஢ ᫮.
    { *p++ = ~*p1++; }                          // ஢ ᫮.
  while (--n1 != 0);                            //  横 ஢.
}

//================================================
//      㭪樨 ᤢ   ᫮ ᫮.
//================================================

//        ᮯ஢ 㢥祭 ᫠ ᫮,
//      ᫨ ⮫쪮 ᤢ ᫮  ࠢ 0.
//       ⥭ 㬭  2  ⥯ (BITS * k1).
//
//      㭪  ॡ ଠ樨 ࠭   ஢
//      ଠ १,  뤠 ଠ
//      १  砥, ᫨ ࠭ ଠ.

void    cBigNumberCopyShl (                     //  p = p1<<(BITS*k1).
                const   EXPTR(long) p1,         //  ᫮.
                        size_t      k1,         // ⥫ ᤢ.
                        EXPTR(long) p           //  ࠧ *p1 + k1 + 1.
        )                                       // p1, p  ᮢ.
{
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  if (n1 <= 1 && p1 [n1] == 0) k1 = 0;          // 㫥 ᫮.
  p1 += n1; *p = n1 + k1; p += (n1 + k1);
  if (n1)
  do                                            //  ஢ ᫮.
    { *p-- = *p1--; }                           // ஢ ᫮.
  while (--n1 != 0);                            //  横 ஢.
  if (k1)
  do                                            //  㫥 ᫮.
    { *p-- = 0; }                               // 㫥 ᫮.
  while (--k1 != 0);                            //  横 㫥.
}

//       ࠢ 믮  ࠭  ᫠.
//       ⥭   2  ⥯ (BITS * k1).

void    cBigNumberCopyShr (                     //  p = p1>>(BITS*k1).
                const   EXPTR(long) p1,         //  ᫮.
                        size_t      k1,         // ⥫ ᤢ.
                        EXPTR(long) p           //  ࠧ *p1 - k1 + 1.
        )                                       // p1, p  ᮢ.
{
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮,
  if (n1 > k1)                                  // ॡ ஢.
  {
    p1 += (k1 + 1);                             // .
    *p++ = (n1 -= k1);                          // ᫮ ᫮.
    do                                          //  ஢ ᫮.
      { *p++ = *p1++; }                         // ஢ ᫮.
    while (--n1 != 0);                          //  横 ஢.
  }
  else { *p++ = 1; *p = p1 [n1] >> (BITS-1); }  // ᫮ 0  -1.
}

//      १ । ᫠   ᫠
//        襣 0-᫮.

void    cBigNumberCutOut (                      // १.
                const   EXPTR(long) p1,         // 㥬 ᫮.
                        size_t      k1,         // 砫쭠 .
                        size_t      n,          // ᫮ ᫮.
                        EXPTR(long) p           //  ࠧ n1 + 1.
        )                                       // p1, p  ᮢ.
{
  assert ((size_t)(*p1) >= k1 + n);             // ஢ઠ ࠧ.
  *p++ = n + 1;                                 // ᫮ ᫮.
  if (n > 0)                                    // ॡ ஢.
  {
    p1 += (k1 + 1);                             // 砫.
    do                                          //  ஢ ᫮.
      { *p++ = *p1++; }                         // ஢ ᫮.
    while (--n != 0);                           //  横 ஢.
  }
  *p = 0;                                       // 襥 ᫮.
}

//================================================
//       樨.
//================================================

//         ⥬ ⮢ ᨨ  ਡ 1.
//      1) 塞  ᫮   ࢮ 㫥 १.
//      2) 㥬 ᫥騥 ᫮.
//      3) ᫨ ᫥ ᫮ ,  襥 ᫮ ࠢ 100..(⮢),
//           㫥 ᫮.
//         ᫨   ᫮ १ ࠢ 11..  100..(⮢),
//          㤠 襥 ᫮.
//
//      㭪  ॡ ଠ樨 ࠭   ஢
//      ଠ १,  뤠 ଠ
//      १  砥, ᫨ ࠭ ଠ.

size_t  _cBigNumberNeg (                        //   p = -p1.
                const   EXPTR(long) p1,         // 室 ᫮.
                        EXPTR(long) p           //  ࠧ *p1 + 2.
        )                                       // p1, p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);                  // ᫮ ᫮.
  p++;
  size_t n = n1;                                // 稪 ᫮.
  if (n)
  do                                            //  ᬥ .
  {
    long lp;                                    // ⨬ ᫮.
    if ((*p = lp = -*p1) != 0)                  //  .
    {                                           // 祭 㫥 ᫮.
      if (--n != 0)                             //   ᫮?
      {                                         // ᫨ ᫮ :
        do                                      //  ᨨ.
          { ++p1; ++p; *p = lp = ~*p1; }        // ⮢  ᫮.
        while (--n != 0);                       //  横 ᨨ.
        return (n1 - (lp == (p[-1]>>(BITS-1))));//  襣 ᫮,
      }                                         // ᫨  譥.

      if (lp != LONG_MIN) return (n1);          // ᫨  ᫮ , 
      p [1] = 0; return (n1 + 1);               // ஢ઠ ९ 
    }                                           //  襣 ᫮.
  }
  while ((++p1, ++p, --n) != 0);                //  横 ᬥ .

  return (n1);                                  //  ᫮ 㫥.
}
//#define cBigNumberNeg(p1,p)   (size_t)(*(p)=_cBigNumberNeg(p1,p))

//      ਡ 1:
//      1) ਡ  ᫮ 1   ࢮ 㫥 १.
//      2) ᫨ ᫥ ᫮ ,  襥 ᫮ ࠢ 100..(⮢),
//           㫥 ᫮.
//         ᫨   ᫮ १ ࠢ 11..  100..(⮢),
//          㤠 襥 ᫮.
//
//      㭪  ॡ ଠ樨 ࠭   ஢
//      ଠ १,  뤠 ଠ
//      १  砥, ᫨ ࠭ ଠ.

size_t  _cBigNumberMInc (                       //  p1 = p1 + 1.
                        EXPTR(long) p1          //  ࠧ *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  // ᫮ ᫮.
  size_t n = n1;                                // 稪 ᫮.

  if (n)                                        //     ᫮.
  {
    do                                          //  ਡ 1.
    {
      long lp;                                  // ⨬ ᫮.
      if ((*p1 = lp = *p1 + 1) != 0)            // ਡ 1.
      {                                         // 祭 㫥 ᫮.
        if (--n != 0)                           //   ᫮?
        {
          if (--n != 0) return (n1);            // ᫨ ⠫ 1 ᫮
          return (n1 - (p1[1]==(lp>>(BITS-1))));//   譥,  㤠.
        }
        if (lp != LONG_MIN) return (n1);        // ᫨  ᫮ , 
        p1 [1] = 0; return (n1 + 1);            // ஢ઠ ९ 
      }                                         //  襣 ᫮.
    }
    while ((++p1, --n) != 0);                   //  横 ਡ 1.
  }
  else { *p1 = 1; n1 = 1; }                     // ଠ ⮣ ᫠.

  return (n1);                                  //  ᫮ 㫥.
}
//#define cBigNumberMInc(p1)    (size_t)(*(p1)=_cBigNumberMInc(p1))

//      ⠭ 1:
//      1)   ᫮ 1   ࢮ १, ⫨筮  ~0.
//      2) ᫨ ᫥ ᫮ ,  襥 ᫮ ࠢ 011..(⮢),
//           筮 ᫮.
//         ᫨   ᫮ १ ࠢ 00..  011..(⮢),
//          㤠 襥 ᫮.
//
//      㭪  ॡ ଠ樨 ࠭   ஢
//      ଠ १,  뤠 ଠ
//      १  砥, ᫨ ࠭ ଠ.

size_t  _cBigNumberMDec (                       // ⠭ p1 = p1 - 1.
                        EXPTR(long) p1          //  ࠧ *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  // ᫮ ᫮.
  size_t n = n1;                                // 稪 ᫮.

  if (n)                                        //     ᫮.
  {
    do                                          //  ⠭ 1.
    {
      long lp;                                  // ⨬ ᫮.
      if ((*p1 = lp = *p1 - 1) != ~0)           // ⠭ 1.
      {                                         // 祭 筮 ᫮.
        if (--n != 0)                           //   ᫮?
        {
          if (--n != 0) return (n1);            // ᫨ ⠫ 1 ᫮
          return (n1 - (p1[1]==(lp>>(BITS-1))));//   譥,  㤠.
        }
        if (lp != LONG_MAX) return (n1);        // ᫨  ᫮ , 
        p1 [1] = ~0; return (n1 + 1);           // ஢ઠ ९ 
      }                                         //  襣 ᫮.
    }
    while ((++p1, --n) != 0);                   //  横 ⠭ 1.
  }
  else { *p1 = -1; n1 = 1; }                    // ଠ ⮣ ᫠.

  return (n1);                                  //  ᫮ .
}
//#define cBigNumberMDec(p1)    (size_t)(*(p1)=_cBigNumberMDec(p1))

//        믮 ᫥⥫쭮  ७ᮬ
//      襣 ࠧ鸞  ᫥饥 ᫮  ନ஢
//        ᫮, 祭 ७ 
//      ࠧ鸞 襣 ᫮. ᫨  ᫥ ࠧ鸞
//      襣 ᫮  ᮢ,  ࠧ ᫠ 㢥稢
//       1, ..  ᫮ ⠭ .
//
//      㭪  ॡ ଠ樨 ࠭   ஢
//      ଠ १,  뤠 ଠ
//      १  砥, ᫨ ࠭ ଠ.

size_t  _cBigNumberMMul2 (                      //  p1 <<= 1.
                        EXPTR(long) p1          //  ࠧ *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  // ᫮ ᫮.
  size_t n = n1;                                // 稪 ᫮.
  long num = 0;                                 //   ᤢ.
  if (n)
  do                                            //  ᤢ ᫮.
  {
    long pass = (unsigned long)num >> (BITS-1); //   ।饣 ᫮.
    num = *p1;                                  // 饥 ᫮  ᤢ.
    *p1++ = (num << 1) | pass;                  // 饥 ᫮ ᫥ ᤢ.
  }
  while (--n != 0);                             //  横 ᤢ ᫮.

  num >>= (BITS-2);                             // ७ 
  n1 += (num != (*p1 = num >> 1));              //  ९.

  return (n1);                                  // 뤠 ᫮ ᫮.
}
//#define cBigNumberMMul2(p1)   (size_t)(*(p1)=_cBigNumberMMul2(p1))

//      ਠ ᤢ   ஢.

size_t  _cBigNumberMul2 (                       //  p = p1 << 1.
                const   EXPTR(long) p1,         // ࠭.
                        EXPTR(long) p           //  ࠧ *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  // ᫮ ᫮.
  p++;
  long num = 0;                                 //   ᤢ.
  size_t n = n1;                                // 稪 ᫮.

  if (n)
  do                                            //  ᤢ ᫮.
  {
    long pass = (unsigned long)num >> (BITS-1); //   ।饣 ᫮.
    num = *p1++;                                // 饥 ᫮  ᤢ.
    *p++ = (num << 1) | pass;                   // 饥 ᫮ ᫥ ᤢ.
  }
  while (--n != 0);                             //  横 ᤢ ᫮.

  num >>= (BITS-2);                             // ७ 
  n1 += (num != (*p = num >> 1));               //  ९.

  return (n1);                                  // 뤠 ᫮ ᫮.
}
//#define cBigNumberMul2(p1,p)  (size_t)(*(p)=_cBigNumberMul2(p1,p))

//       ࠢ 믮 ᫥⥫쭮  ७ᮬ
//      襣 ࠧ鸞  ।饥 ᫮.
//       襣 ᫮ , ⠫ - .
//      ᫨  ᤢ  ࠧ 襣 ᫮ ᮢ,
//       襥 ᫮ १ 㤠.
//
//      㭪  ॡ ଠ樨 ࠭   ஢
//      ଠ १,  뤠 ଠ
//      १  砥, ᫨ ࠭ ଠ.

size_t  _cBigNumberMDiv2 (                      //  p1 <<= 1.
                        EXPTR(long) p1          //  ࠧ *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  size_t n = n1;                                // 稪 ᫮.
  p1 += n;                                      // 襥 ᫮.
  if (n)                                        //  ᫮?
  {
    if (--n != 0)                               //   ᫮.
    {
      long num = *p1;                           // 襥 ᫮  ᤢ.
      n1 -= (num == (*p1-- = (num >> 1)));      //  襣 ᫮  
                                                // 㤠, ᫨ 0  ~0.
      do                                        //  ᤢ ᫮.
      {
        long pass = num << (BITS-1);            //   ᫥饣 ᫮.
        num = *p1;                              // 饥 ᫮  ᤢ.
        *p1-- = ((unsigned long)num>>1) | pass; // 饥 ᫮ ᫥ ᤢ.
      }
      while (--n != 0);                         //  横 ᤢ ᫮.
    }
    else                                        // 쪮  ᫮.
    {
      (*p1) >>= 1;                              // .
    }
  }
  return (n1);                                  // 뤠 ᫮ ᫮.
}
//#define cBigNumberMDiv2(p1)   (size_t)(*(p1)=_cBigNumberMDiv2(p1))

//      ਠ ᤢ ࠢ  ஢.

size_t  _cBigNumberDiv2 (                       //  p = p1 << 1.
                const   EXPTR(long) p1,         // ࠭.
                        EXPTR(long) p           //  ࠧ *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  size_t n = n1;                                // 稪 ᫮.
  p1 += n;                                      // 襥 ᫮.
  p  += n;                                      // 襥 ᫮.
  if (n)                                        //  ᫮?
  {
    if (--n != 0)                               //   ᫮.
    {
      long num = *p1--;                         // 襥 ᫮  ᤢ.
      n1 -= (num == (*p-- = (num >> 1)));       //  襣 ᫮  
                                                // 㤠, ᫨ 0  ~0.
      do                                        //  ᤢ ᫮.
      {
        long pass = num << (BITS-1);            //   ᫥饣 ᫮.
        num = *p1--;                            // 饥 ᫮  ᤢ.
        *p-- = ((unsigned long)num>>1) | pass;  // 饥 ᫮ ᫥ ᤢ.
      }
      while (--n != 0);                         //  横 ᤢ ᫮.
    }
    else                                        // 쪮  ᫮.
    {
      *p = (*p1) >> 1;                          // .
    }
  }
  return (n1);                                  // 뤠 ᫮ ᫮.
}

//#define cBigNumberDiv2(p1,p)  (size_t)(*(p)=_cBigNumberDiv2(p1,p))

//================================================
//      ଠ  ଠ.
//================================================

//      ଠ  쭮  ᫮,
//      ॡ  ࠭ ᫠ (  1).

size_t  _cBigNumberFit  (                       // ଠ.
                        EXPTR(long) p1          //    ᫮.
        )                                       //     2.
{
  register size_t n1 = (size_t)(*p1);           // ᫮ ᫮.
  p1 += n1;                                     // ⮢ 㪠⥫.
  register long pass;                           // 襥 ᫮.
  register long lp;                             // ।饥 ᫮.

  if (n1)                                       // ᫨  襬 ᫮  
  {                                             // 襬  ।饣
    lp = *p1;                                   // ᫮  0   1, 
    do continue;                                // 㤠 襥 ᫮.
    while (--n1 != 0 &&
        (pass = lp, lp = p1 [-1], --p1, pass == (lp>>(BITS-1))));
  }                                             // ᫨   ᫮ ,
  else { p1 [1] = 0; }                          //  㫥 ᫮.

  return (n1 + 1);                              // 뤠 ᫮ ᫮.
}
//#define cBigNumberFit(p1)     (size_t)(*(p1)=_cBigNumberFit(p1))

//      ଠ  㢥祭 ᫠ ᫮  
//      稭. ᫨  稭   室
//      ᫠ ᫮,  ᫮ ᫮ 㢥稢  1.

size_t  _cBigNumberFitTo (                      // ଠ.
                        EXPTR(long) p1,         //    ᫮.
                        size_t n                // ᫮ ᫮.
        )                                       //    
{                                               // max(n+1,n1+2).
  register size_t n1 = (size_t)(*p1);           // ᫮ ᫮.
  register long pass = p1 [n1] >> (BITS-1);     // ७.

  do
  {
     p1 [++n1] = pass;                          // ࠭塞 ७.
  }
  while (n1 < n);

  return (n1);                                  // 뤠 ᫮ ᫮.
}
//#define cBigNumberFitTo(p1,n) (size_t)(*(p1)=_cBigNumberFitTo(p1,n))

//================================================
//      ⮢ ⠡ ᤢ.
//================================================

//      ᫮ ଠ,   ⮬   ᫥ ᫠
//      ନ ⠡ ᤢ  1..BITS-1  蠣 *p + 2.
//      㭪 ᥣ 뤠 ଠ ᫮ 
//      ଠ ᤢ;  ⮬ ⢮ 訥
//      ᫮  ७ﬨ  ࠧ冷.
//      ᫥ ⮣ ᫮  ⢮  ⨬஢
//      , ᯮ ⠡ ᤢ.

void    cBigNumberTab  (                        // ⮢ ⠡ ᤢ.
                        EXPTR(long) p           // ᫮   ࠧ
        )                                       // (*p + 2) * BITS + 1
                                                //   ᤢ
{                                               // p<<1..BITS-1  蠣 *p + 2.
  size_t n = cBigNumberFit (p);                 //   .
  int ns = BITS - 1;                            // 稪 ⮢ ᤢ.
  p [n + 1] = p [n] >> (BITS-1);                // ७ .
  n += 2;
  EXPTR(long) pp = p;                           // 稩 㪠⥫.
  do                                            // .
  {
    pp += n;
    cBigNumberMul2 (p, pp);                     //  ᫠  .
    p = pp;
  }
  while (--ns > 0);                             //  横  ᫮.
}

//================================================
//      ᪨ 㭪樨.
//================================================

//       믮 樨  ࠧ  ᥫ
//       ⠪, ⮡  ᫠ ᮤঠ max(n1,n2)
//      ᫮. 祭 ᫮ ࠡ뢠 ᫮.
//       㪮稢   ,  襥
//      ᫮  㤥 ⫨  १ ७
//      襣 ࠧ鸞 ।᫥ ᫮.

//      ᮡ ॠ樨:
//      - ।,  ன ࠭   ࢮ.
//      - 㭪樨 ᥣ 뤠 ଠ ᫮.
//      -  楫 ⨬樨  䠪᪮ ७
//         ࠧ鸞 ਬ ⬨᪨ .

size_t  _cBigNumberXor  (                       //  mod 2 p = p1 ^ p2
                const   EXPTR(long) p1,         // ࠭.
                const   EXPTR(long) p2,         // ࠭ (  p1).
                        EXPTR(long) p           //  ࠧ *p1 + 1.
        )                                       // p1, p2, p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);                  // ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);                  // ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  {
    register long lp2 = 0;                      // 饥 ᫮ p2;

//      ࠡ⪠ ᫮ p1, p2.

    {
      size_t n;                                 // 稪 ᫮.
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ ^ (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //  横  p1, p2.
      }
    }

//      ࠡ⪠ ⪠ p1, ᫨ p1  p2.

    {
      lp2 >>= (BITS-1);                         //  ࠧ p2.
      size_t n;                                 // 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ ^ lp2; }              //   p1.
        while (--n != 0);                       //  横  p1.
      }
    }
    --p;                                        // ⮢ 㪠⥫.
  }

//      ଠ - 㤠 譨  ᫮ p,   0  1
//       ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long pass;                         // 襥 ᫮.
    register long lp;                           // ।饥 ᫮.
    register size_t n = n1;                     // ᫮ ᫮.
    if (n)                                      // ᫨  襬 ᫮  
    {                                           // 襬  ।饣
      lp = *p;                                  // ᫮  0   1, 
      do --p;                                   // 㤠 襥 ᫮.
      while
        (--n != 0 && (pass = lp, lp = *p, pass == (lp>>(BITS-1))));
    }                                           // ᫨   ᫮ ,
    else { p [1] = 0; }                         //  㫥 ᫮.

    return (n + 1);                             // 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberXor(p1,p2,p) (size_t)(*(p)=_cBigNumberXor(p1,p2,p))

size_t  _cBigNumberAnd  (                       //  p = p1 & p2
                const   EXPTR(long) p1,         // ࠭.
                const   EXPTR(long) p2,         // ࠭ (  p1).
                        EXPTR(long) p           //  ࠧ *p1 + 1.
        )                                       // p1, p2, p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);                  // ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);                  // ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  {
    register long lp2 = 0;                      // 饥 ᫮ p2;

//      ࠡ⪠ ᫮ p1, p2.

    {
      size_t n;                                 // 稪 ᫮.
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ & (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //  横  p1, p2.
      }
    }

//      ࠡ⪠ ⪠ p1, ᫨ p1  p2.

    {
      lp2 >>= (BITS-1);                         //  ࠧ p2.
      size_t n;                                 // 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ & lp2; }              //   p1.
        while (--n != 0);                       //  横  p1.
      }
    }
    --p;                                        // ⮢ 㪠⥫.
  }

//      ଠ - 㤠 譨  ᫮ p,   0  1
//       ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long pass;                         // 襥 ᫮.
    register long lp;                           // ।饥 ᫮.
    register size_t n = n1;                     // ᫮ ᫮.
    if (n)                                      // ᫨  襬 ᫮  
    {                                           // 襬  ।饣
      lp = *p;                                  // ᫮  0   1, 
      do continue;                              // 㤠 襥 ᫮.
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp>>(BITS-1))));
    }                                           // ᫨   ᫮ ,
    else { p [1] = 0; }                         //  㫥 ᫮.

    return (n + 1);                             // 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberAnd(p1,p2,p) (size_t)(*(p)=_cBigNumberAnd(p1,p2,p))

size_t  _cBigNumberOr  (                        //  p = p1 & p2
                const   EXPTR(long) p1,         // ࠭.
                const   EXPTR(long) p2,         // ࠭ (  p1).
                        EXPTR(long) p           //  ࠧ *p1 + 1.
        )                                       // p1, p2, p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);                  // ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);                  // ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  {
    register long lp2 = 0;                      // 饥 ᫮ p2;

//      ࠡ⪠ ᫮ p1, p2.

    {
      size_t n;                                 // 稪 ᫮.
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ | (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //  横  p1, p2.
      }
    }

//      ࠡ⪠ ⪠ p1, ᫨ p1  p2.

    {
      lp2 >>= (BITS-1);                         //  ࠧ p2.
      size_t n;                                 // 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ | lp2; }              //   p1.
        while (--n != 0);                       //  横  p1.
      }
    }
    --p;                                        // ⮢ 㪠⥫.
  }

//      ଠ - 㤠 譨  ᫮ p,   0  1
//       ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long pass;                         // 襥 ᫮.
    register long lp;                           // ।饥 ᫮.
    register size_t n = n1;                     // ᫮ ᫮.
    if (n)                                      // ᫨  襬 ᫮  
    {                                           // 襬  ।饣
      lp = *p;                                  // ᫮  0   1, 
      do continue;                              // 㤠 襥 ᫮.
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp>>(BITS-1))));
    }                                           // ᫨   ᫮ ,
    else { p [1] = 0; }                         //  㫥 ᫮.

    return (n + 1);                             // 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberOr(p1,p2,p)  (size_t)(*(p)=_cBigNumberOr(p1,p2,p))

//================================================
//      㭪樨 ᫮  ⠭.
//================================================

//       ᫮  ᥫ  ࠧ  ᥫ
//       ⠪, ⮡  ᫠ ᮤঠ max(n1,n2)+1
//      ᫮. 祭 ᫮ ᪫뢠 ᫮  ࠡ⪮
//      ७ᮢ   ᫮  㣮. 祭 ⠪
//      ࠧ ᫮ 㪮稢   ,  襥
//      ᫮  㤥 ⫨  १ ७
//      襣 ࠧ鸞 ।᫥ ᫮.
//
//      ᮡ ॠ樨:
//      - ।,  ன ࠭   ࢮ.
//      - 㭪 ᥣ 뤠 ଠ ᫮.
//      -  楫 ⨬樨  䠪᪮ ७
//         ࠧ鸞 ਬ ⬨᪨ .

size_t  _cBigNumberAdd  (                       //  p = p1 + p2
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //  ࠧ *p1 + 2.
        )                                       // p1, p2, p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);                  // ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);                  // ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  register unsigned long pass = 0;              // ७  ᫥饥 ᫮ p.
        // ७ ᯮ  襬  pass
        // unsigned long ᯥ稢 ᤢ pass >>  ७ .
  {
    register long lp1 = 0;                      // 饥 ᫮ p1;
    register long lp2 = 0;                      // 饥 ᫮ p2;

//      㬬஢ ᫮ p1, p2.

    {
      size_t n;                                 // 稪 ᫮.
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = *p1++; lp2 = *p2++;
          pass = (~(*p++ = (pass>>(BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                         | (lp1 & lp2);
        }
        while (--n != 0);                       //  横  p1, p2.
      }
    }

//      ७   p1, ᫨ p1  p2.

    {
      size_t n;                                 // 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
        register const long *pp = p1;           // ⨬.
        if ((lp2 & LONG_MIN) == 0)              // p2 ⥫쭮.
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //  横  p1.
        }
        else                                    // p2 ⥫쭮.
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //  横  p1.
        }
      }
    }
    --p;                                        // ⮢ 㪠⥫.

//      㬬஢ ७  ࠧ冷 p1, p2.
//      祭 ⠪ ࠧ 襥 ᫮ p ⮨ ⮫쪮  0  1.
//      襥 ᫮ p   pass.

    pass = (pass>>(BITS-1)) + ((lp1)>>(BITS-1)) + ((lp2)>>(BITS-1));
  }

//      ଠ - 㤠 譨  ᫮ p,   0  1
//       ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long lp = *p;                      // ।饥 ᫮.
    register size_t n = n1;                     // ᫮ ᫮, ஬ 襣.
    if (n && (long)pass == (lp>>(BITS-1)))      // ᫨  襬 ᫮  
    {                                           // 襬  ।饣
      do continue;                              // ᫮  0   1, 
      while (--n != 0 &&                        // 㤠 襥 ᫮.
        (pass = lp, lp = p [-1], --p, (long)pass == (lp>>(BITS-1))));
    }
    else { p [1] = pass; }                      //  襣 ᫮.

    return (n + 1);                             // 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberAdd(p1,p2,p) (size_t)(*(p)=_cBigNumberAdd(p1,p2,p))

//       ⠭  ᥫ  ࠧ  ᥫ
//       ⠪, ⮡  ᫠ ᮤঠ max(n1,n2)+1
//      ᫮. 祭 ᫮  ᫮  ࠡ⪮
//      ७ᮢ   ᫮  㣮. 祭 ⠪
//      ࠧ ᫮ 㪮稢   ,  襥
//      ᫮  㤥 ⫨  १ ७
//      襣 ࠧ鸞 ।᫥ ᫮.
//
//      ᮡ ॠ樨:
//      - ।,  ன ࠭   ࢮ.
//      - 㭪樨 ᥣ 뤠 ଠ ᫮.
//      -  楫 ⨬樨  䠪᪮ ७
//         ࠧ鸞 ਬ ⬨᪨ .
//      -  ⠭ ॠ   ਠ:
//        筮 ⠭  ⠭  ᬥ .

size_t  _cBigNumberSub  (                       // ⠭ p = p1 - p2
                const   EXPTR(long) p1,         // ⠥.
                const   EXPTR(long) p2,         // ⥫ (  p1).
                        EXPTR(long) p           //  ࠧ *p1 + 2.
        )                                       // p1, p2, p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);                  // ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);                  // ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  register unsigned long pass = ~0UL;   // ७  ᫥饥 ᫮ p.
        // ७ ᯮ  襬  pass
        // unsigned long ᯥ稢 ᤢ pass >>  ७ .
        // 砫쭮 祭 ᯥ稢 ਡ .
  {
    register long lp1 = 0;                      // 饥 ᫮ p1;
    register long lp2 = ~0;                     // 饥 ᫮ ~p2;

//      㬬஢ ᫮ p1, ~p2.

    {
      size_t n;                                 // 稪 ᫮.
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = *p1++; lp2 = ~(*p2++);
          pass = (~(*p++ = (pass>>(BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                         | (lp1 & lp2);
        }
        while (--n != 0);                       //  横  p1, p2.
      }
    }

//      ७   p1, ᫨ p1  p2.

    {
      size_t n;                                 // 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
        register const long *pp = p1;           // ⨬.
        if ((lp2 & LONG_MIN) == 0)              // p2 ⥫쭮.
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //  横  p1.
        }
        else                                    // p2 ⥫쭮.
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //  横  p1.
        }
      }
    }
    --p;                                        // ⮢ 㪠⥫.

//      㬬஢ ७  ࠧ冷 p1, p2~.
//      祭 ⠪ ࠧ 襥 ᫮ p ⮨ ⮫쪮  0  1.
//      襥 ᫮ p   pass.

    pass = (pass>>(BITS-1)) + ((lp1)>>(BITS-1)) + ((lp2)>>(BITS-1));
  }

//      ଠ - 㤠 譨  ᫮ p,   0  1
//       ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long lp = *p;                      // ।饥 ᫮.
    register size_t n = n1;                     // ᫮ ᫮, ஬ 襣.
    if (n && (long)pass == (lp>>(BITS-1)))      // ᫨  襬 ᫮  
    {                                           // 襬  ।饣
      do continue;                              // ᫮  0   1, 
      while (--n != 0 &&                        // 㤠 襥 ᫮.
        (pass = lp, lp = p [-1], --p, (long)pass == (lp>>(BITS-1))));
    }
    else { p [1] = pass; }                      //  襣 ᫮.

    return (n + 1);                             // 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberSub(p1,p2,p) (size_t)(*(p)=_cBigNumberSub(p1,p2,p))

//      ⠭  ᬥ .

size_t  _cBigNumberSubS (                       // ⠭ p = p2 - p1
                const   EXPTR(long) p1,         // ⥫.
                const   EXPTR(long) p2,         // ⠥ (  p1).
                        EXPTR(long) p           //  ࠧ *p1 + 2.
        )                                       // p1, p2, p  ᮢ.
{
  size_t n1 = (size_t)(*p1++);                  // ᫮ ᫮.
  size_t n2 = (size_t)(*p2++);                  // ᫮ ᫮.
  p++;
  assert (n1 >= n2);

  register unsigned long pass = ~0UL;           // ७  ᫥饥 ᫮ p.
        // ७ ᯮ  襬  pass
        // unsigned long ᯥ稢 ᤢ pass >>  ७ .
        // 砫쭮 祭 ᯥ稢 ਡ .
  {
    register long lp1 = ~0;                     // 饥 ᫮ ~p1;
    register long lp2 = 0;                      // 饥 ᫮ p2;

//      㬬஢ ᫮ ~p1, p2.

    {
      size_t n;                                 // 稪 ᫮.
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = ~(*p1++); lp2 = *p2++;
          pass = (~(*p++ = (pass>>(BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                         | (lp1 & lp2);
        }
        while (--n != 0);                       //  横  p1, p2.
      }
    }

//      ७   p1, ᫨ p1  p2.

    {
      size_t n;                                 // 稪 ᫮.
      if ((n = n1 - n2) != 0)
      {
        register const long *pp = p1;           // ⨬.
        if ((lp2 & LONG_MIN) == 0)              // p2 ⥫쭮.
        {
          do                                    //   p1.
          {
            lp1 = ~(*pp++);
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //  横  p1.
        }
        else                                    // p2 ⥫쭮.
        {
          do                                    //   p1.
          {
            lp1 = ~(*pp++);
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //  横  p1.
        }
      }
    }
    --p;                                        // ⮢ 㪠⥫.

//      㬬஢ ७  ࠧ冷 ~p1, p2.
//      祭 ⠪ ࠧ 襥 ᫮ p ⮨ ⮫쪮  0  1.
//      襥 ᫮ p   pass.

    pass = (pass>>(BITS-1)) + ((lp1)>>(BITS-1)) + ((lp2)>>(BITS-1));
  }

//      ଠ - 㤠 譨  ᫮ p,   0  1
//       ᮢ  ७  ࠧ鸞 ।饣 ᫮.

  {
    register long lp = *p;                      // ।饥 ᫮.
    register size_t n = n1;                     // ᫮ ᫮, ஬ 襣.
    if (n && (long)pass == (lp>>(BITS-1)))      // ᫨  襬 ᫮  
    {                                           // 襬  ।饣
      do continue;                              // ᫮  0   1, 
      while (--n != 0 &&                        // 㤠 襥 ᫮.
        (pass = lp, lp = p [-1], --p, (long)pass == (lp>>(BITS-1))));
    }
    else { p [1] = pass; }                      //  襣 ᫮.

    return (n + 1);                             // 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberSubS(p1,p2,p) (size_t)(*(p)=_cBigNumberSubS(p1,p2,p))

//================================================
//      樠஢ 㭪樨 
//       ⬮ 㬭  .
//================================================

//      㭪  㫥 ᫮.

static  size_t  _cBigNumberSkip = 0;            // ᫮ 0-᫮ + 1

size_t  cBigNumberSkipLow0 (                    //  0-᫮.
                const   EXPTR(long) p1          //    ᫮.
)                                               // 뤠 ᫮ 0-᫮ + 1.
{
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮ p1.
  size_t n = 1;                                 // ᫮ 0-᫮ p1 + 1.

  if (n1 != 0)
  do
  {
    if (p1 [n] != 0) break;                     // 諨 㫥 ᫮.
    n++;
  }
  while (--n1 != 0);

  return _cBigNumberSkip = n;                   // ᫮ 0-᫮ + 1
}

//      樠஢ ᫮  ᤢ ண ᫠
//       㪠 ᫮ ᫮. ਬ  㬭.
//
//       楫 ⨬樨 ।, :
//      -  ࢮ ᫠  , 祬 ࠧ ண ᫠
//        ᫥ ᤢ.
//      -  ண ᫠  ᤢ  0.
//      -  १  , 祬 ࠧ ࢮ ᫠.
//      । ᫮  뢠 㭪 cBigNumberSkipLow0()
//        ᫠  0-᫮  ஬ ᫠.
//
//      㭪  ॡ ଠ樨 ࠭,  ஢
//      ଠ १    ࠧ ࢮ ᫠.

#ifndef _CBIGNUM_ASM                            // ᫨  ।.

void    cBigNumberMAddM  (                      //  p1 += p2<<k2*BITS
                        EXPTR(long) p1,         // , ⮬ १.
                const   EXPTR(long) p2,         //  ࠧ <= n1-k2.
                        size_t k2               //  ᫠ .
        )                                       // p1, p2  ᮢ.
{
  assert (_cBigNumberSkip > 0);                 // ஢ઠ ࠬ.
  const EXPTR(long) pp = p1 + (size_t)(*p1);    // ᫥ ᫮ p1.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮ p2.
  assert ((size_t)(*p1) >= n2 + k2);            // ஢ઠ ࠧ.
  assert (n2 > 0);                              // ஢ઠ ࠧ.
  p1 += k2;                                     // ⠡஢ p2.

//      㬬஢ ᫮ p1, p2.
//       横  ࠦ:
//      pass = ((~(*p1 = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
//                                                       | (lp1 & lp2))
//      ᪮ ࠦ ᯨᠭ   楯窨 ᢠ:
//      pass += (lp1 + lp2)     // *p1 = pass
//      lp1  = ~(lp1 ^ lp2)     // ᢠ lp1 ᢮ ॣ.
//      pass = ~(pass | lp1)    // ᯮ ࠢ  ࣠
//      pass |= (lp1 & lp2)     //  ⮦⢮ a & b = ~(a^b) & b.
//      ᢠ ࠧ ஢ઠ ᫮ 横  饭ﬨ
//      㪠⥫  ⨬樨 㧪 ஢ Pentium.

  register unsigned long pass = 0;              // ७: 0  1.
        // unsigned long ᯥ稢 ᤢ pass >>  ७ .
  {
    const EXPTR(long) pp = p1 + n2;             // ᫥ ᫮ p2.
    p1 += _cBigNumberSkip;                      // ४ 砫 p1.
    p2 += _cBigNumberSkip;                      // ४ 砫 p2.
    register long lp1;                          // 饥 ᫮ p1;
    register long lp2;                          // 饥 ᫮ p2;

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              // 騥 ᫮ p1, p2;
      pass += lp1;      lp1 ^= lp2;
      pass += lp2;      lp1 = ~lp1;
      *p1 = pass;       pass |= lp1;
      lp1 &= lp2;       pass = ~pass;
      ++p2;             pass |= lp1;
      if (p1 >= pp)     break;
      ++p1;             pass >>= (BITS-1);
    }
    if ((long)(lp2 ^= pass) >= 0) return;       // ७ .
  }

//      ७   p1, ᫨ p1  p2.
//      ।᫮: p1 㪠뢠  ᫥ 祭 ᫮,
//                   pass ᮤন ७  襬 .
  {
    register long lp1;                          // 饥 ᫮ p1;
    if ((long)pass < 0)                         // p2 ⥫쭮.
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 + 1) & lp1) < 0);
    }
    else                                        // p2 ⥫쭮.
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 - 1) | lp1) >= 0);
    }
  }
}

#endif//_CBIGNUM_ASM

//      樠஢ ⠭  ᤢ ண ᫠
//       㪠 ᫮ ᫮. ਬ  .
//
//       楫 ⨬樨 ।, :
//      - ᫠   .
//      -  ࢮ ᫠  , 祬 ࠧ ண ᫠
//        ᫥ ᤢ.
//      -  ண ᫠  ᤢ  0.
//      - ᫥ ⠭ ᫮    ᫥ 㬥蠥.
//      - ᫥ ⠭  ᫠  ,
//        ஬ 㫥 ⥫ ᥫ.
//      । ⠭  뢠 㭪 cBigNumberSkipLow0()
//        ᫠  0-᫮  ⠥.
//
//      㭪  ॡ ଠ樨 ࠭ 
//      ᥣ 뤠 ଠ ᫮.

#ifndef _CBIGNUM_ASM                            // ᫨  ।.

size_t  _cBigNumberMSubD (                      // ⠭ p1 -= p2<<k2*BITS
                        EXPTR(long) p1,         // ⠥, ⮬ १.
                const   EXPTR(long) p2,         // ⥫ ࠧ <= n1-k2.
                        size_t k2               //  ⥫ .
        )                                       // p1, p2  ᮢ.
{
  assert (_cBigNumberSkip > 0);                 // ஢ઠ ࠬ.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮ p2.
  assert ((p1 [(size_t)(*p1)] ^ p2 [n2]) >= 0); // ஢ઠ .
  assert ((size_t)(*p1) >= n2 + k2);            // ஢ઠ ࠧ.
  assert (n2 > 0);                              // ஢ઠ ࠧ.
  p1 += k2;                                     // ⠡஢ p2.

//       横  ࠦ:
//      pass = (((*p1 = (pass >> (BITS-1)) + lp1 - lp2) | (lp1 ^ lp2))
//                                                     & (~lp1 | lp2))
//      ᪮ ࠦ ᯨᠭ   楯窨 ᢠ:
//      pass += (lp1 + lp2)     // *p1 = pass
//      pass += (lp1 ^= lp2)    // ᢠ lp1 ᢮ ॣ.
//      pass &=~(lp1 & ~lp2)    // ᯮ ࠢ  o࣠
//                              //  ⮦⢮ a & ~b = (a^b) & ~b.
//      ᢠ ࠧ ஢ઠ ᫮ 横  饭ﬨ
//      㪠⥫  ⨬樨 㧪 ஢ Pentium.

  register long pass = 0;                       // : 0  -1.
        // long ᯥ稢 ᤢ pass >>  ७ .
  {
    const EXPTR(long) pp = p1 + n2;             // ᫥ ᫮ p2.
    p1 += _cBigNumberSkip;                      // ४ 砫 p1.
    p2 += _cBigNumberSkip;                      // ४ 砫 p2.
    register long lp1;                          // 饥 ᫮ p1;
    register long lp2;                          // 饥 ᫮ p2;

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              // 騥 ᫮ p1, p2;
      pass += lp1;      lp1 ^= lp2;
      pass -= lp2;      lp2 = ~lp2;
      *p1 = pass;       lp2 &= lp1;
      if (p1 >= pp)     break;
      lp2 = ~lp2;       pass |= lp1;
      ++p1;             pass &= lp2;
      ++p2;             pass >>= (BITS-1);
    }
  }

//      ଠ - 㤠 譨  ᫮ p,   0  1
//       ᮢ  ७  ࠧ鸞 ।饣 ᫮.
//      ।᫮: p1 㪠뢠  ᫥ 祭 ᫮,
//                    ண 室  pass.
  {
    register size_t n1 = n2 + k2;

//       横 믮 樨:
//      do continue;
//      while (--n1 != 0 &&
//              lp1==(lp1 = pass, pass = p1[-1], --p1, pass>>(BITS-1)));

    for (;;)
    {
      register long lp1;                        // 襥 ᫮.
      register long lp2;                        // ।饥 ᫮.
      if (--n1 == 0)    break;                  // ⠫  ᫮.
      lp2 = p1[-1];     --p1;
      lp1 = pass;       pass = lp2;
      lp2 >>= (BITS-1);
      if (lp1 != lp2)   break;
    }
    return (n1 + 1);                            // 뤠 ᫮ ᫮ p.
  }
}
//#define cBigNumberMSubD(p1,p2,k2) (size_t)(*(p1)=_cBigNumberMSubD(p1,p2,k2))

//      樠஢ ᤢ   1 .
//      ਬ  㬭.
//
//      ।, :
//      - ᫮ ᮤন 㫥 ᫮.
//      । ᤢ  뢠 㭪 cBigNumberSkipLow0()
//        ᫠  0-᫮  .
//
//        믮 ᫥⥫쭮  ७ᮬ
//      襣 ࠧ鸞  ᫥饥 ᫮  ନ஢
//        ᫮, 祭 ७ 
//      ࠧ鸞 襣 ᫮. ᫨  ᫥ ࠧ鸞
//      襣 ᫮  ᮢ,  ࠧ ᫠ 㢥稢
//       1, ..  ᫮ ⠭ .
//
//      㭪  ॡ ଠ樨 ࠭   ஢
//      ଠ १,  뤠 ଠ
//      १  砥, ᫨ ࠭ ଠ.

size_t  _cBigNumberMMul2M (                     //  p1 <<= 1.
                        EXPTR(long) p1          //  ࠧ *p1 + 2.
        )
{
  assert (_cBigNumberSkip > 0);                 // ஢ઠ ࠬ.
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  assert (n1 >= _cBigNumberSkip);               // ஢ઠ ࠧ.

  const EXPTR(long) pp = p1 + n1;               // ᫥ ᫮ p1.
  p1 += _cBigNumberSkip;                        // 襥 ᫮.
  long num = 0;                                 //   ᤢ.
  do                                            //  ᤢ ᫮.
  {
    long pass = (unsigned long)num >> (BITS-1); //   ।饣 ᫮.
    num = *p1;                                  // 饥 ᫮  ᤢ.
    *p1++ = (num << 1) | pass;                  // 饥 ᫮ ᫥ ᤢ.
  }
  while (p1 <= pp);                             //  ᤢ ᫮.

  num >>= (BITS-2);                             // ७ 
  n1 += (num != (*p1 = num >> 1));              //  ९.

  return (n1);                                  // 뤠 ᫮ ᫮.
}
//#define cBigNumberMMul2M(p1)   (size_t)(*(p1)=_cBigNumberMMul2M(p1))

//      樠஢ ᤢ ࠢ  1 .
//      ਬ    ᫥ ⭮ .
//
//      ।, :
//      - ᫮ 㫥.
//      - 訩  襣 㫥 ᫮ 㫥.
//      । ᫮  뢠 㭪 cBigNumberSkipLow0()
//        ᫠  0-᫮  .
//
//       ࠢ 믮 ᫥⥫쭮  ७ᮬ
//      襣 ࠧ鸞  ।饥 ᫮.
//       襣 ᫮ , ⠫ - .
//      ᫨  ᤢ  ࠧ 襣 ᫮ ᮢ,
//       襥 ᫮ १ 㤠.
//
//      㭪  ॡ ଠ樨 ࠭   ஢
//      ଠ १,  뤠 ଠ
//      १  砥, ᫨ ࠭ ଠ.

size_t  _cBigNumberMDiv2D (                     //  p1 <<= 1.
                        EXPTR(long) p1          //  ࠧ *p1 + 1.
        )
{
  assert (_cBigNumberSkip > 0);                 // ஢ઠ ࠬ.
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  assert (n1 >= _cBigNumberSkip);               // ஢ઠ ࠧ.
  assert ((p1 [_cBigNumberSkip] & 1L) == 0);    // ஢ઠ 襣 .

  const EXPTR(long) pp = p1 + _cBigNumberSkip;  // ࢮ 㫥 ᫮ p1.
  p1 += n1;                                     // 襥 ᫮.
  long num = *p1;                               // 襥 ᫮  ᤢ.
  n1 -= (n1 > 1) & (num == (*p1-- = num >> 1)); //  襣 ᫮  
                                                // 㤠, ᫨ 0  ~0.
  while (p1 >= pp)                              //  ᤢ ᫮.
  {
    long pass = num << (BITS-1);                //   ᫥饣 ᫮.
    num = *p1;                                  // 饥 ᫮  ᤢ.
    *p1-- = ((unsigned long)num >> 1) | pass;   // 饥 ᫮ ᫥ ᤢ.
  }                                             //  横 ᤢ ᫮.

  return (n1);                                  // 뤠 ᫮ ᫮.
}
//#define cBigNumberMDiv2D(p1)   (size_t)(*(p1)=_cBigNumberMDiv2D(p1))

#endif//_CBIGNUM_ASM

//       ᫠   ᫮ ࠢ ( 㬭).
//      室 ᫮  ᮤঠ,  ,  ᫮.

void    cBigNumberMShrM (                       //  p1>>=BITS.
                        EXPTR(long) p1          //  ࠧ *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  assert (n1 > 1);                              // ஢ઠ.
  *p1 = --n1;
  do                                            //  ஢ ᫮.
    { p1 [1] = p1 [2]; p1++; }                  // ஢ ᫮.
  while ((int)--n1 > 0);                        //  横 ஢.
}

//       ᫠   ᫮  ( ).
//      室 ᫮  ᮤঠ,  ,  ᫮.

void    cBigNumberMShlD (                       //  p1<<=BITS.
                        EXPTR(long) p1          //  ࠧ *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  assert (n1 > 0);                              // ஢ઠ.
  *p1  = n1 + 1;
  do                                            //  ஢ ᫮.
    { p1 [n1 + 1] = p1 [n1]; }                  // ஢ ᫮.
  while ((int)--n1 > 0);                        //  横 ஢.
  p1 [1] = 0;
}

//================================================
//      稥 .
//================================================

static  cBigNumber   cBigBuf1;  // .
static  cBigNumber   cBigBuf2;  // ⥫, ⥫, ७.
static  cBigNumber   cBigBuf3;  // 筮 㬭.
static  cBigNumber   cBigBuf4;  // ⥯  .

//================================================
//      㭪樨 㬭.
//================================================

//      樠஢ 㭪 㬭  ᤢ.
//      ।,  ⥫ ⥫,  
//          祬 ॡ  ࠧ.
//      .  㤥 .
//
//      㭪  ॡ ଠ樨 ⥫  ᥣ 뤠
//      ଠ १.

void    cBigNumberMAddMulShl (                  //  p+=p1*p2<<k*BITS.
                        EXPTR(long) p1,         //    ࠧ
                                                // *p1 + 2, .
                const   EXPTR(long) p2,         // ⥫.
                        size_t      k,          //  ந .
                        EXPTR(long) p           //    ࠧ
                                                // max (*p1 + *p2 + k, *p) + 2.
        )                                       // p1,p2,p   ᮢ.
{
  assert (_cBigNumberSkip == 0);                // ஢ઠ ࠬ.
  assert (cBigNumberIsFit (p1));                // ஢ઠ ଠ樨.
  assert (p1 != p);                             // ஢ઠ ᮢ.
  assert (p2 != p);                             // ஢ઠ ᮢ.
  assert (p2 != p1);                            // ஢ઠ ᮢ.
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮.
  assert (p2 [n2] >= 0);                        // ⥫쭮.

//       㬭,  ਬ騩 ⠡ ᤢ.

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) // ࠭ .
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // ଠ.
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //   ᫮ p2.
    {
      long num = p2 [k2 + 1];                   // ᫥ ᫮ p2.
      if (num == 0) continue;                   // ⨬.
      long mask = 1;                            // ᪠  ⮢ num.
      for (;; cBigNumberMMul2M (p1))            //   ⠬ ᫮ p2.
      {
        if (num & mask) cBigNumberMAddM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  稫.
      }                                         //  横  ⠬ p2.
      cBigNumberMMul2M (p1);                    //    .
      cBigNumberMShrM (p1);                     // ⠭ .
    }                                           //  横  ᫮ p2.
    {
      long num = p2 [k2 + 1];                   // ᫥ ᫮ p2.
      long mask = (num != 0);                   // ᪠  ⮢ num.
      if (num > 0)                              // 訩  num 
      do                                        //   0  pp2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  // 訩  num ࠢ 0.
      for (;; cBigNumberMMul2M (p1))            //   ⠬ ᫮ p2.
      {
        if (num & mask) cBigNumberMAddM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  稫.
      }                                         //  横  ⠬ p2.
    }
  }
  cBigNumberFit (p);                            // ଠ.
  EXDEBUG (_cBigNumberSkip = 0);                // ⫠筮 㫥.
}

//      樠஢ 㭪 㬭  ⠡楩 ᤢ.
//      ।,  ⥫ ⥫,   
//       室 ⠡ ᤢ, 祭 㭪樥
//      cBigNumberTab().
//
//      㭪  ॡ ଠ樨 ⥫  ᥣ 뤠
//      ଠ १.

void    cBigNumberMAddMulTab (                  //  p+=p1*p2<<k*BITS.
                const   EXPTR(long) p1,         //   ⠡ ᤢ.
                const   EXPTR(long) p2,         // ⥫.
                        size_t      k,          //  ந .
                        EXPTR(long) p           //    ࠧ
                                                // max (*p1 + *p2 + k, *p) + 2.
        )                                       // p1, p2  ᮢ.
{
  assert (_cBigNumberSkip == 0);                // ஢ઠ ࠬ.
  assert (cBigNumberIsFit (p1));                // ஢ઠ ଠ樨.
  assert (p1 != p);                             // ஢ઠ ᮢ.
  assert (p2 != p);                             // ஢ઠ ᮢ.
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮.
  assert (p2 [n2] >= 0);                        // ⥫쭮.

//       㬭  ⠡楩 ᤢ.

  if (n1 >= cBigNumberSkipLow0 (p1))            //  ⮥.
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // ଠ.
    n1 += 2;                                    //  ⠡ ᤢ.
    for (size_t k2 = 0; k2 != n2; k2++)         //   ᫮ p2.
    {
      long num = p2 [k2 + 1];                   // । ᫮ p2.
      long mask = 1;                            // ᪠  ⮢ num.
      const EXPTR(long) pp1 = p1;               // 騩 ᤢ.
      for (;; pp1 += n1)                        //   ⠬ ᫮ p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k + k2);
        if ((mask <<= 1) == 0) break;           //  稫.
      }                                         //  横  ⠬ p2.
    }                                           //  横  ᫮ p2.
  }

  cBigNumberFit (p);                            // ଠ.
  EXDEBUG (_cBigNumberSkip = 0);                // ⫠筮 㫥.
}

//      ᠫ쭠 㭪 㬭   ࠡ⠥ 
//      ᫠     ॡ  ।⥫쭮
//      ⮢ ⠡ ᤢ. ᫨  ᪮ 㬭,
//       㭪 ᠬ ந ६ ⠡ ᤢ, 
//      ਬ ,  ᯮ騩 ⠡ ᤢ.
//      㭪  ॡ ଠ樨 ࠭  ᥣ 뤠
//      ଠ १.

void    cBigNumberMAddMul (                     //  p += p1 * p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         // ⥫.
                        EXPTR(long) p           //    ࠧ
                                                // max (*p1 + *p2 + 3, *p + 2).
        )                                       // p1, p2, p  ᮢ.
{
  assert (_cBigNumberSkip == 0);                // ஢ઠ ࠬ.
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮.

  cBigBuf1.checkexpand ((n2 <= SHIFT_TAB_MIN)? (n1 + 3):
                        (n1 < SHIFT_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                  size_max (n1 + 3, (SHIFT_TAB_HIGH + 3) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                // । .
  EXPTR(long) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   ⥫.

  if (p2 [n2] >= 0)                             // ⥫ ⥫:
  {                                             // ஢.
    cBigNumberCopy (p1, pp1);
    cBigNumberCopy (p2, pp2);
  }
  else                                          // ⥫ ⥫:
  {                                             // ᬥ .
    cBigNumberNeg  (p1, pp1);
    cBigNumberNeg  (p2, pp2);
  }
  assert (pp2 [(size_t)(*pp2)] >= 0);           // ஢ઠ .

//        ⠡楩 ᤢ.

  if (n2 > SHIFT_TAB_MIN)
  {
    size_t k = 0;                               // 砫  窠.
    if (k + (SHIFT_TAB_HIGH) < n1)
    {
      cBigBuf3.checkexpand ((SHIFT_TAB_OPT + 3) * BITS + 1);
      EXPTR(long) pp3 = EXPTRTYPE(cBigBuf3);
      do                                        //   窠.
      {
        cBigNumberCutOut (pp1, k, SHIFT_TAB_OPT, pp3);
        cBigNumberTab (pp3);                    // ⮢ ⠡ ᤢ.
        cBigNumberMAddMulTab (pp3, pp2, k, p);  //  窠.
        k += SHIFT_TAB_OPT;
      }
      while (k + (SHIFT_TAB_HIGH) < n1);
      cBigNumberCopyShr (pp1, k, pp1);          // ᫥ 祪.
    }
    cBigNumberTab (pp1);                        // ⮢ ⠡ ᤢ.
    cBigNumberMAddMulTab (pp1, pp2, k, p);      // .
    EXDEBUG (cBigBuf1 = 0);                     // ⫠筮 㫥.
    EXDEBUG (cBigBuf2 = 0);                     // ⫠筮 㫥.
    EXDEBUG (cBigBuf3 = 0);                     // ⫠筮 㫥.
    EXDEBUG (_cBigNumberSkip = 0);              // ⫠筮 㫥.
    return;
  }

//      ,  ਬ騩 ⠡ ᤢ.

  if (n1 >= cBigNumberSkipLow0 (pp1) && n2 != 0)// ࠭ .
  {
    cBigNumberFitTo (p, n1 + n2 + 1);           // ଠ.
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //   ᫮ p2.
    {
      long num = pp2 [k2 + 1];                  // ᫥ ᫮ p2.
      if (num == 0) continue;                   // ⨬.
      long mask = 1;                            // ᪠  ⮢ num.
      for (;; cBigNumberMMul2M (pp1))           //   ⠬ ᫮ p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k2);
        if ((mask <<= 1) == 0) break;           //  稫.
      }                                         //  横  ⠬ p2.
      cBigNumberMMul2M (pp1);                   //    .
      cBigNumberMShrM (pp1);                    // ⠭ .
    }                                           //  横  ᫮ p2.
    {
      long num = pp2 [k2 + 1];                  // ᫥ ᫮ p2.
      long mask = (num != 0);                   // ᪠  ⮢ num.
      if (num > 0)                              // 訩  num 
      do                                        //   0  pp2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  // 訩  num ࠢ 0.
      for (;; cBigNumberMMul2M (pp1))           //   ⠬ ᫮ p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k2);
        if ((mask <<= 1) == 0) break;           //  稫.
      }                                         //  横  ⠬ p2.
    }
  }
  cBigNumberFit (p);                            // ଠ.
  EXDEBUG (cBigBuf1 = 0);                       // ⫠筮 㫥.
  EXDEBUG (cBigBuf2 = 0);                       // ⫠筮 㫥.
  EXDEBUG (cBigBuf3 = 0);                       // ⫠筮 㫥.
  EXDEBUG (_cBigNumberSkip = 0);                // ⫠筮 㫥.
}

//      ᠫ쭠 㭪 㬭   ࠡ⠥ 
//      ᫠     ॡ  ।⥫쭮
//      ⮢ ⠡ ᤢ. ᫨  ᪮ 㬭,
//       㭪 ᠬ ந ६ ⠡ ᤢ, 
//      ਬ ,  ᯮ騩 ⠡ ᤢ.
//      㭪  ॡ ଠ樨 ࠭  ᥣ 뤠
//      ଠ १.

void    cBigNumberMul (                         //  p = p1 * p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         // ⥫.
                        EXPTR(long) p           //  ࠧ *p1 + *p2 + 3.
        )                                       // p1, p2, p  ᮢ.
{
  assert (_cBigNumberSkip == 0);                // ஢ઠ ࠬ.
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮.

  cBigBuf1.checkexpand ((n2 <= SHIFT_TAB_MIN)? (n1 + 3):
                        (n1 < SHIFT_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                  size_max (n1 + 3, (SHIFT_TAB_HIGH + 3) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                // । ,
  EXPTR(long) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   ⥫.

  if (p2 [n2] >= 0)                             // ⥫ ⥫:
  {                                             // ஢.
    cBigNumberCopy (p1, pp1);
    cBigNumberCopy (p2, pp2);
  }
  else                                          // ⥫ ⥫:
  {                                             // ᬥ .
    cBigNumberNeg  (p1, pp1);
    cBigNumberNeg  (p2, pp2);
  }
  assert (pp2 [(size_t)(*pp2)] >= 0);           // ஢ઠ .
  p [0] = 0;                                    // 㫥 ந.

//        ⠡楩 ᤢ.

  if (n2 > SHIFT_TAB_MIN)
  {
    size_t k = 0;                               // 砫  窠.
    if (k + (SHIFT_TAB_HIGH) < n1)
    {
      cBigBuf3.checkexpand ((SHIFT_TAB_OPT + 3) * BITS + 1);
      EXPTR(long) pp3 = EXPTRTYPE(cBigBuf3);
      do                                        //   窠.
      {
        cBigNumberCutOut (pp1, k, SHIFT_TAB_OPT, pp3);
        cBigNumberTab (pp3);                    // ⮢ ⠡ ᤢ.
        cBigNumberMAddMulTab (pp3, pp2, k, p);  //  窠.
        k += SHIFT_TAB_OPT;
      }
      while (k + (SHIFT_TAB_HIGH) < n1);
      cBigNumberCopyShr (pp1, k, pp1);          // ᫥ 祪.
    }
    cBigNumberTab (pp1);                        // ⮢ ⠡ ᤢ.
    cBigNumberMAddMulTab (pp1, pp2, k, p);      // .
    EXDEBUG (cBigBuf1 = 0);                     // ⫠筮 㫥.
    EXDEBUG (cBigBuf2 = 0);                     // ⫠筮 㫥.
    EXDEBUG (cBigBuf3 = 0);                     // ⫠筮 㫥.
    EXDEBUG (_cBigNumberSkip = 0);              // ⫠筮 㫥.
    return;
  }

//      ,  ਬ騩 ⠡ ᤢ.

  if (n1 >= cBigNumberSkipLow0 (pp1) && n2 != 0)// ࠭ .
  {
    cBigNumberFitTo (p, n1 + n2 + 1);           // ଠ.
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //   ᫮ p2.
    {
      long num = pp2 [k2 + 1];                  // ᫥ ᫮ p2.
      if (num == 0) continue;                   // ⨬.
      long mask = 1;                            // ᪠  ⮢ num.
      for (;; cBigNumberMMul2M (pp1))           //   ⠬ ᫮ p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k2);
        if ((mask <<= 1) == 0) break;           //  稫.
      }                                         //  横  ⠬ p2.
      cBigNumberMMul2M (pp1);                   //    .
      cBigNumberMShrM (pp1);                    // ⠭ .
    }                                           //  横  ᫮ p2.
    {
      long num = pp2 [k2 + 1];                  // ᫥ ᫮ p2.
      long mask = (num != 0);                   // ᪠  ⮢ num.
      if (num > 0)                              // 訩  num 
      do                                        //   0  pp2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  // 訩  num ࠢ 0.
      for (;; cBigNumberMMul2M (pp1))           //   ⠬ ᫮ p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k2);
        if ((mask <<= 1) == 0) break;           //  稫.
      }                                         //  横  ⠬ p2.
    }
  }
  cBigNumberFit (p);                            // ଠ.
  EXDEBUG (cBigBuf1 = 0);                       // ⫠筮 㫥.
  EXDEBUG (cBigBuf2 = 0);                       // ⫠筮 㫥.
  EXDEBUG (cBigBuf3 = 0);                       // ⫠筮 㫥.
  EXDEBUG (_cBigNumberSkip = 0);                // ⫠筮 㫥.
}

//================================================
//      㭪, ࠡ뢠   0.
//================================================

size_t  cBigNumberMaskDiv0;                     // ᪠   0:
                                                //  0 - 訡 Divide Error
void    cBigNumberDiv0 (void)                   // >0 - ஢
{
  cBigNumberMaskDiv0 /= cBigNumberMaskDiv0;
}

//================================================
//      㭪樨 .
//================================================

//      樠஢ 㭪   ⠡楩 ᤢ.
//      ।,    ⥫ ଠ
//         ,    ⥫ 室
//      ⠡ ᤢ, 祭 㭪樥 cBigNumberTab.
//
//      㭪 । ⭮   ⮪   .
//      ⭮ >= 0.  ⪠ ᮢ   .
//      㭪 ᥣ 뤠 ଠ ⭮  ⮪.

void    cBigNumberMModDivTab (                  //  p = p1/p2, p1 %= p2
                        EXPTR(long) p1,         // , ⮬ - ⮪.
                const   EXPTR(long) p2,         // ⥫  ⠡ ᤢ.
                        EXPTR(long) p           //  ࠧ *p1 + 2.
        )                                       // p1,p2,p   ᮢ.
{
  assert (_cBigNumberSkip == 0);                // ஢ઠ ࠬ.
  assert (cBigNumberIsFit (p1));                // ஢ઠ ଠ樨.
  assert (cBigNumberIsFit (p2));                // ஢ઠ ଠ樨.
  assert (p1 != p);                             // ஢ઠ ᮢ.
  assert (p2 != p);                             // ஢ઠ ᮢ.
  assert (p2 != p1);                            // ஢ઠ ᮢ.
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮.
  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;       // 稪 ᫮  ⭮.
  assert ((p1 [n1] ^ p2 [n2]) >= 0);            //  .

//       ⭮   㫥 ᫮   砩,
//      ᫨ 訩  ⭮ 㤥 ⠭  .
//      ᫨ 㫥 ᫮ 㤥 譨,   㤥 㤠
//       ଠ樨.

  *p = n + 1; p += n; p [1] = 0;                // 砫  p.

//      ந ⠫ ᫮.

  n2 += 2;                                      //  ⠡ ᤢ.
  cBigNumberSkipLow0 (p2);                      // ய  0-᫮.
  if (cBigNumberNot0 (p2))                      // ஢ઠ   0.
  {
    long lt = (p1 [n1] < 0) * 2 - 1;            // ⠭  ࠢ
                                                // ᮫ 祭 ᥫ.
                                                // (p1 >= 0)? -1: 1
    const EXPTR(long) pp2 = p2;                 // 稩 㪠⥫.
    do                                          //   ᫮ ⭮.
    {
      --n;                                      // 稪 ᫮ ⭮.
      pp2 += n2 * BITS;                         //  ⥫  ᫮.
      unsigned long mask = (1L << (BITS-1));    // 砫쭠 ᪠.
      *p = 0;                                   // 㫥 ᫮ ⭮.
      do                                        //   ⠬ ⭮.
      {
        pp2 -= n2;                              // 騩 ᤢ.
        assert (*pp2 >= (long)(n2 - 2) && *pp2 <  (long) n2);
                                                //  ⠡ ᤢ?
        int diff = n - (size_t)(*p1)            //  ࠧ஢.
                     + (size_t)(*pp2);
        if (diff <= 0 && (diff < 0 ||           // ᫨ ⮪  
            cBigNumberCompHigh (p1, pp2) != lt))// ᤢ⮣ ⥫,
        {                                       //  ஢
          cBigNumberMSubD (p1, pp2, n);         // ⠭ ⥫ 
          (*p) += mask;                         // ⠭  ⭮.
        }
      }
      while ((mask >>= 1) != 0);                //  横  ⠬.
      --p;                                      //  ⭮ ନ஢.
    }
    while (n);                                  //  横  ᫮.
    assert (cBigNumberComp (p1, pp2) == lt);    // ⮪  ⥫?
  }
  else                                          //   0.
  {                                             // ᫨   0
    cBigNumberDiv0();                           // ࠧ襭,  ⮪
    do { *p-- = 0; } while (--n);               // 㤥 ࠢ .
  }
  cBigNumberFit (p);                            // ଠ ⭮.
  assert (p [(size_t)(*p)] >= 0);               // ஢ઠ ⥫쭮.
  EXDEBUG (_cBigNumberSkip = 0);                // ⫠筮 㫥.
}

//      ᠫ쭠 㭪  ࠡ⠥  ᫠   
//       ॡ  ।⥫쭮 ⮢ ⠡ ᤢ.
//      ᫨  ᪮ ,  㭪 ᠬ ந ६ ⠡
//      ᤢ,  ਬ ,  ᯮ騩 ⠡ ᤢ.
//
//      㭪 । ⭮   ⮪   .
//       ⭮ -  ந    ⥫.
//       ⪠ ᮢ   .
//      㭪 ᥣ 뤠 ଠ ⭮  ⮪.

void    cBigNumberMModDiv (                     //  p = p1/p2, p1 %= p2
                        EXPTR(long) p1,         // , ⮬ - ⮪.
                const   EXPTR(long) p2,         // ⥫.
                        EXPTR(long) p           //  ࠧ *p1 + 3.
        )                                       // p2  ᮢ  p1, p.
{
  assert (_cBigNumberSkip == 0);                // ஢ઠ ࠬ.
  assert (p1 != p);                             // ஢ઠ ᮢ.

//      ⮢   ⥫: ஢ ଠ
//        ᯥ稢 ᮢ .

  size_t n1 = (size_t) cBigNumberFit (p1);      // ᫮ ᫮.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮.
  int nt = (int) ((SHIFT_TAB_MIN + n2 - n1) & (n1 - SHIFT_TAB_MAX));

  cBigBuf2.checkexpand ((nt < 0)? ((n2 + 3) * BITS + 1): (n2 + 3));
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   ⥫.

  long signdiv;                                 //  㫥 ⭮.
  if ((p1 [n1] ^ p2 [n2]) >= 0)                 //  ᮢ:
    { cBigNumberCopy (p2, pp2); signdiv = 1; }  // ஢ ⥫.
  else                                          //   ᮢ:
    { cBigNumberNeg (p2, pp2); signdiv = -1; }  // ᬥ  ⥫.

//        ⠡楩 ᤢ.

  if (nt < 0)
  {
    cBigNumberTab (pp2);                        // ⮢ ⠡ ᤢ.
    cBigNumberMModDivTab (p1, pp2, p);          // .
    if (signdiv < 0) cBigNumberNeg (p, p);      //  .
    EXDEBUG (cBigBuf2 = 0);                     // ⫠筮 㫥.
    EXDEBUG (_cBigNumberSkip = 0);              // ⫠筮 㫥.
    return;
  }

//      ,  ਬ騩 ⠡ ᤢ.

  n2 = cBigNumberFit (pp2);                     // ଠ ⥫.
  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;       // 稪 ᫮  ⭮.

//       ⭮   㫥 ᫮   砩,
//      ᫨ 訩  ⭮ 㤥 ⠭  .
//      ᫨ 㫥 ᫮ 㤥 譨,   㤥 㤠
//       ଠ樨.

  *p = n + 1; p += n; p [1] = 0;                // 砫  p.

//      ந ⠫ ᫮.

  cBigNumberSkipLow0 (pp2);                     // ய  0-᫮.
  if (cBigNumberNot0 (pp2))                     // ஢ઠ   0.
  {
    assert ((p1 [n1] ^ pp2 [n2]) >= 0);         // ஢ઠ ᮢ .
    long lt = (p1 [n1] < 0) * 2 - 1;            // ⠭  ࠢ
                                                // ᮫ 祭 ᥫ
                                                // (p1 >= 0)? -1: 1
    do                                          //   ᫮ ⭮.
    {
      --n;                                      // 稪 ᫮ ⭮.
      *p = 0;                                   // 㫥 ᫮ ⭮.
      cBigNumberMShlD (pp2);                    //  ⥫  ᫮.
      unsigned long mask = (1UL << (BITS-1));   // 砫쭠 ᪠.
      do                                        //   ⠬ ⭮.
      {
        int diff = cBigNumberMDiv2D (pp2) + n - //  ⥫  .
                   (size_t)(*p1);               //  ࠧ஢.
        if (diff <= 0 && (diff < 0 ||           // ᫨ ⮪  
            cBigNumberCompHigh (p1, pp2) != lt))// ᤢ⮣ ⥫,
        {                                       //  ஢
          cBigNumberMSubD (p1, pp2, n);         // ⠭ ⥫ 
          (*p) += mask;                         // ⠭  ⭮.
        }
      }
      while ((mask >>= 1) != 0);                //  横  ⠬.
      --p;                                      //  ⭮ ନ஢.
    }
    while (n);                                  //  横  ᫮.
    assert (cBigNumberComp (p1, pp2) == lt);    // ⮪  ⥫?
  }
  else
  {                                             // ᫨   0
    cBigNumberDiv0();                           // ࠧ襭,  ⮪
    do { *p-- = 0; } while (--n);               // 㤥 ࠢ .
  }
  cBigNumberFit (p);                            // ଠ ⭮.
  assert (p [(size_t)(*p)] >= 0);               // ஢ઠ ⥫쭮.
  if (signdiv < 0) cBigNumberNeg (p, p);        //  .
  EXDEBUG (cBigBuf2 = 0);                       // ⫠筮 㫥.
  EXDEBUG (_cBigNumberSkip = 0);                // ⫠筮 㫥.
}

//================================================
//      㭪樨 ᫥ ⪠.
//================================================

//      樠஢ 㭪 ⪠  ⠡楩 ᤢ.
//      ।,    ⥫ ଠ
//         ,    ⥫ 室
//      ⠡ ᤢ, 祭 㭪樥 cBigNumberTab.
//
//      㭪 ᫥ ⪠  ᮪饭 ਠ⮬
//      㭪樨 ,  ன ᪫祭 ᫥ ⭮.
//      㭪  ⮪   .
//       ⪠ ᮢ   .
//      㭪 ᥣ 뤠 ଠ ᫮.

void    cBigNumberMModTab (                     // ⮪ p1 %= p2.
                        EXPTR(long) p1,         // , ⮬ - ⮪.
                const   EXPTR(long) p2          // ⥫  ⠡ ᤢ.
        )                                       // p1, p2   ᮢ.
{
  assert (_cBigNumberSkip == 0);                // ஢ઠ ࠬ.
  assert (cBigNumberIsFit (p1));                // ஢ઠ ଠ樨.
  assert (cBigNumberIsFit (p2));                // ஢ઠ ଠ樨.
  assert (p1 != p2);                            // ஢ઠ ᮢ.
  size_t n1 = (size_t)(*p1);                    // ᫮ ᫮.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮.
  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;       // 稪 ᫮  ⭮.
  assert ((p1 [n1] ^ p2 [n2]) >= 0);            //  .

//      ⢥ .

  n2 += 2;                                      //  ⠡ ᤢ.
  cBigNumberSkipLow0 (p2);                      // ய  0-᫮.
  if (cBigNumberNot0 (p2))                      // ஢ઠ   0.
  {
    long lt = (p1 [n1] < 0) * 2 - 1;            // ⠭  ࠢ
                                                // ᮫ 祭 ᥫ
                                                // (p1 >= 0)? -1: 1
    const EXPTR(long) pp2 = p2;                 // 稩 㪠⥫.
    do                                          //   ᫮ ⭮.
    {
      --n;                                      // 稪 ᫮ ⭮.
      pp2 += n2 * BITS;                         //  ⥫  ᫮.
      unsigned long mask = (1UL << (BITS-1));   // 砫쭠 ᪠.
      do                                        //   ⠬ ⭮.
      {
        pp2 -= n2;                              // 騩 ᤢ.
        assert (*pp2 >= (long)(n2 - 2) && *pp2 <  (long) n2);
                                                //  ⠡ ᤢ?
        int diff = n - (size_t)(*p1)            //  ࠧ஢.
                     + (size_t)(*pp2);
        if (diff <= 0 && (diff < 0 ||           // ᫨ ⮪  
            cBigNumberCompHigh (p1, pp2) != lt))// ᤢ⮣ ⥫,
        {                                       //  ஢
          cBigNumberMSubD (p1, pp2, n);         // ⠭ ⥫.
        }
      }
      while ((mask >>= 1) != 0);                //  横  ⠬.
    }
    while (n);                                  //  横  ᫮.
    assert (cBigNumberComp (p1, pp2) == lt);    // ⮪  ⥫?
  }
  else                                          //   0.
  {                                             // ᫨   0
    cBigNumberDiv0();                           // ࠧ襭,  ⮪
  }                                             // 㤥 ࠢ .
  EXDEBUG (_cBigNumberSkip = 0);                // ⫠筮 㫥.
}

//      ᠫ쭠 㭪 ⪠ ࠡ⠥  ᫠   
//       ॡ  ।⥫쭮 ⮢ ⠡ ᤢ.
//      ᫨  ᪮ ,  㭪 ᠬ ந ६ ⠡
//      ᤢ,  ਬ ,  ᯮ騩 ⠡ ᤢ.

//      㭪 ᫥ ⪠  ᮪饭 ਠ⮬
//      㭪樨 ,  ன ᪫祭 ᫥ ⭮.
//      㭪  ⮪   .
//       ⪠ ᮢ   .
//      㭪 ᥣ 뤠 ଠ ᫮.

void    cBigNumberMMod (                        // ⮪ p1 %= p2.
                        EXPTR(long) p1,         // , ⮬ - ⮪.
                const   EXPTR(long) p2          // ⥫.
        )                                       // p1, p2  ᮢ.
{
  assert (_cBigNumberSkip == 0);                // ஢ઠ ࠬ.

//      ⮢   ⥫: ஢ ଠ
//        ᯥ稢 ᮢ .

  size_t n1 = (size_t) cBigNumberFit (p1);      // ᫮ ᫮.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮.
  int nt = (int) ((SHIFT_TAB_MIN + n2 - n1) & (n1 - SHIFT_TAB_MAX));

  cBigBuf2.checkexpand ((nt < 0)? ((n2 + 3) * BITS + 1): (n2 + 3));
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   ⥫.

  if ((p1 [n1] ^ p2 [n2]) >= 0)                 //  ᮢ:
    { cBigNumberCopy (p2, pp2); }               // ஢ ⥫.
  else                                          //   ᮢ:
    { cBigNumberNeg  (p2, pp2); }               // ᬥ  ⥫.

//        ⠡楩 ᤢ.

  if (nt < 0)
  {
    cBigNumberTab (pp2);                        // ⮢ ⠡ ᤢ.
    cBigNumberMModTab (p1, pp2);                // ⮪.
    EXDEBUG (cBigBuf2 = 0);                     // ⫠筮 㫥.
    EXDEBUG (_cBigNumberSkip = 0);              // ⫠筮 㫥.
    return;
  }

//      ,  ਬ騩 ⠡ ᤢ.

  n2 = cBigNumberFit (pp2);                     // ଠ ⥫.
  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;       // 稪 ᫮  ⭮.
  cBigNumberSkipLow0 (pp2);                     // ய  0-᫮.
  if (cBigNumberNot0 (pp2))                     // ஢ઠ   0.
  {
    assert ((p1 [n1] ^ pp2 [n2]) >= 0);         // ஢ઠ ᮢ .
    long lt = (p1 [n1] < 0) * 2 - 1;            // ⠭  ࠢ
                                                // ᮫ 祭 ᥫ.
                                                // (p1 >= 0)? -1: 1
    do                                          //   ᫮ ⭮.
    {
      --n;                                      // 稪 ᫮ ⭮.
      cBigNumberMShlD (pp2);                    //  ⥫  ᫮.
      unsigned long mask = (1UL << (BITS-1));   // 砫쭠 ᪠.
      do                                        //   ⠬ ⭮.
      {
        int diff = cBigNumberMDiv2D (pp2) + n - //  ⥫  .
                   (size_t)(*p1);               //  ࠧ஢.
        if (diff <= 0 && (diff < 0 ||           // ᫨ ⮪  
            cBigNumberCompHigh (p1, pp2) != lt))// ᤢ⮣ ⥫,
        {                                       //  ஢
          cBigNumberMSubD (p1, pp2, n);         // ⠭ ⥫.
        }
      }
      while ((mask >>= 1) != 0);                //  横  ⠬.
    }
    while (n);                                  //  横  ᫮.
    assert (cBigNumberComp (p1, pp2) == lt);    // ⮪  ⥫?
  }
  else                                          //   0.
  {                                             // ᫨   0
    cBigNumberDiv0();                           // ࠧ襭,  ⮪
  }                                             // 㤥 ࠢ .
  EXDEBUG (cBigBuf2 = 0);                       // ⫠筮 㫥.
  EXDEBUG (_cBigNumberSkip = 0);                // ⫠筮 㫥.
}

//================================================
//      㭪樨   ⥯.
//================================================

//      㭪   ⥯ ॡ, ⮡ ᭮
//      室   ⠪  ࠧ,    
//       १ 樨.  ᭮ ᯮ,
//       ࠡ稩.  ஢   묨
//       ।⠢ १  ⥫쭮 ᫮
//       㦤 樨 㬭.
//      ⬥⨬,  ᫨  p2   ᫮  p1 ⫨筮
//       -1,0,1,  ࠧ ஢ 㤥   512 M.
//      ⥫ ⥯   ⥫.
//      㭪 ᥣ 뤠 ଠ ᫮.

void    cBigNumberPow (                         //  p1  ⥯ p2.
                        EXPTR(long) p1,         //   ᭮.
                const   EXPTR(long) p2,         // ⥫ >= 0.
                        EXPTR(long) p           //   १.
        )                                       // p1,p2,p   ᮢ.
{                                               // p1 .
  assert (p1 != p);                             // ஢ઠ ᮢ.
  assert (p2 != p);                             // ஢ઠ ᮢ.
  assert (p2 != p1);                            // ஢ઠ ᮢ.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮.
  assert (p2 [n2] >= 0);                        // ⥫쭮.

  p2++;
  p [0] = 1; p [1] = 1;                         // 砫쭠 ⥯.
  if (n2 != 0)
  {
    for (;;)                                    //   ᫮ p2.
    {
      long num = *p2++;                         // । ᫮ p2.
      long mask = 1;                            // ᪠  ⮢ num.
      if (--n2 == 0)                            // 頥 ᫮ 室
      {                                         //  ᫥ 横.
        if (num == 0) break;                    // 襥 ᫮ p2 㫥.
        do                                      // 訩  num ᥣ 0.
          mask <<= 1;                           //  mask  num, 
        while ((num <<= 1) > 0);                // 訩  num ࠢ 0.
      }
      for (;;)                                  //   ⠬ ᫮ p2.
      {
        if (num & mask)
          cBigNumberMul (p1, p, p);             //  ⥯.
        if ((mask <<= 1) == 0) break;           //  稫.
        cBigNumberMul (p1, p1, p1);             //  ᭮.
      }                                         //  横  ⠬ p2.
      if (n2 == 0) break;                       //  稫.
      cBigNumberMul (p1, p1, p1);               //  ᭮.
    }                                           //  横  ᫮ p2.
  }
}

//      㭪   ⥯   ॡ,
//      ⮡ ᭮ 室   㤢
//       ࠢ  㫥 ࠧ + ⥫쭮
//      ᫮  樨 㬭.
//       ᭮ ᯮ,  ࠡ稩.
//      ⥫ ⥯   ⥫.
//      㭪 ᥣ 뤠 ଠ ᫮.

void    cBigNumberPowMod (                      //  p1  ⥯ p2.
                        EXPTR(long) p1,         //   ᭮.
                const   EXPTR(long) p2,         // ⥫ >= 0.
                const   EXPTR(long) mod,        //  ( ᮢ).
                        EXPTR(long) p           //   १.
        )                                       // p1,p2,p   ᮢ.
{                                               // p1 .
  assert (p1 != p);                             // ஢ઠ ᮢ.
  assert (p2 != p);                             // ஢ઠ ᮢ.
  assert (p2 != p1);                            // ஢ઠ ᮢ.
  size_t n2 = (size_t)(*p2);                    // ᫮ ᫮.
  assert (p2 [n2] >= 0);                        // ⥫쭮.
  size_t nmod = (size_t)(*mod);                 // ᫮ ᫮.

  cBigBuf4.checkexpand (exmuladd (BITS, nmod, BITS * 2 + 1));
  EXPTR(long) pmod = EXPTRTYPE(cBigBuf4);       //   .

  long signmod = mod [nmod];                    //  .
  if (signmod >= 0)
    cBigNumberCopy (mod, pmod);                 // ஢ .
  else
    cBigNumberNeg  (mod, pmod);                 //   .
  assert (pmod [(size_t)(*pmod)] >= 0);         // ஢ઠ .
  cBigNumberTab (pmod);                         // ⮢ ⠡ ᤢ.

  p2++;
  p [0] = 1; p [1] = 1;                         // 砫쭠 ⥯.
  cBigNumberMModTab (p,  pmod);                 //  ᭮.
  cBigNumberMModTab (p1, pmod);                 //  ᭮.
  if (n2 != 0)
  {
    for (;;)                                    //   ᫮ p2.
    {
      long num = *p2++;                         // । ᫮ p2.
      long mask = 1;                            // ᪠  ⮢ num.
      if (--n2 == 0)                            // 頥 ᫮ 室
      {                                         //  ᫥ 横.
        if (num == 0) break;                    // 襥 ᫮ p2 㫥.
        do                                      // 訩  num ᥣ 0.
          mask <<= 1;                           //  mask  num, 
        while ((num <<= 1) > 0);                // 訩  num ࠢ 0.
      }
      for (;;)                                  //   ⠬ ᫮ p2.
      {
        if (num & mask)
        {                                       //  ⥯.
          if (*p1 > *p) cBigNumberMul (p1, p, p);
          else          cBigNumberMul (p, p1, p);
          cBigNumberMModTab (p, pmod);          //  ⥯.
        }
        if ((mask <<= 1) == 0) break;           //  稫.
        cBigNumberMul (p1, p1, p1);             //  ᭮.
        cBigNumberMModTab (p1, pmod);           //   ᭮.
      }                                         //  横  ⠬ p2.
      if (n2 == 0) break;                       //  稫.
      cBigNumberMul (p1, p1, p1);               //  ᭮.
      cBigNumberMModTab (p1, pmod);             //   ᭮.
    }                                           //  横  ᫮ p2.
  }
  if (signmod < 0) cBigNumberNeg (p, p);        //  .
  EXDEBUG (cBigBuf4 = 0);                       // ⫠筮 㫥.
}

//================================================
//      㭪 ᫥ ⭮ .
//================================================

//      㭪  楫᫥  ७
//        ⮪   ᭮.
//      㭪 ᥣ 뤠 ଠ ७  ⮪.

void    cBigNumberMRmSqrt (                     //  ७.
                        EXPTR(long) p1,         // ᭮, ⮬ - ⮪.
                        EXPTR(long) p           //  ࠧ *p1/2 + 2.
        )                                       // p1, p   ᮢ.
{
  assert (_cBigNumberSkip == 0);                // ஢ઠ ࠬ.
  assert (p1 != p);                             // ஢ઠ ᮢ.

//      ଠ ᭮.

  size_t n1 = (size_t) cBigNumberFit (p1);      // ᫮ ᫮.
  assert (p1 [n1] >= 0);                        // ⥫쭮.

  cBigBuf2.checkexpand (n1 + 1);                // +1  ⫠筮 ஢ન.
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   ⠥.
  *pp2 = 0;                                     // 㫥.
  cBigNumberFitTo (pp2, n1);                    // .

//      .

  int nbit = (cBigNumberBits (p1) + 1) & ~1;
  if ((nbit -= 2) >= 0)
  {

//      祭 襣  ⥫.

    {
      size_t nw = nbit / BITS;                  // .
      long lw = (1L<<(nbit % BITS));            // ᪠.
      pp2 [nw + 1] += lw;                       // ⠭ .
      assert (pp2 [(size_t)(*pp2)] >= 0);       // ⥫쭮.
      p1  [nw + 1] -= lw;                       // ⠭  ଠ樨.
      assert (p1  [(size_t)(*p1)]  >= 0);       // ⥫쭮.
    }

//      ࠡ⪠ ⠫ ⮢.
//      ⠥  ⥫  ଠ  믮
//      ᫥ 権.

    while ((nbit -= 2) >= 0)                    //   訬 ⠬.
    {
      size_t nw = nbit / BITS;                  // .
      long lw = (1L<<(nbit % BITS));            // ᪠.
      pp2 [nw + 1] += lw;                       // ⠭ .
      _cBigNumberSkip = nw + 1;                 // ய ᫮.
      if (cBigNumberComp (p1, pp2) < 0)         // ࠢ.
      {
        pp2 [nw + 1] -= lw;                     // ⨥ .
        cBigNumberMDiv2D (pp2);                 //  ⥫  .
      }
      else
      {
        cBigNumberMSubD (p1, pp2, 0);           // ४ ⪠.
        assert (p1 [(size_t)(*p1)] >= 0);       // ⥫쭮.
        assert (cBigNumberIsFit (p1));          // ଠ.
        pp2 [nw + 1] -= lw;                     // ⨥ .
        cBigNumberMDiv2D (pp2);                 //  ⥫  .
        pp2 [nw + 1] += lw;                     // ⠭ .
      }
      assert (pp2 [(size_t)(*pp2)] >= 0);       // ⥫쭮.
      assert (cBigNumberIsFit (pp2));           // ଠ.
    }
  }
  cBigNumberFit (pp2);                          // ଠ .
  cBigNumberCopy (pp2, p);                      // ஢ .

  // ஢塞,  祭 ७  訩 ,
  //  ॢ室騩  ࠧ  ᫮.

  assert (cBigNumberComp (
    (_cBigNumberSkip = 1, cBigNumberMMul2M (pp2), pp2), p1) >= 0);

  EXDEBUG (_cBigNumberSkip = 0);                // ⫠筮 㫥.
}

#ifdef  __cplusplus
}
#endif//__cplusplus
