/* --------------------------------------------------------------
    ᪨ ᨢ  ⮬᪮ ஢મ .
    㭪樨 । .

    http://www.imach.uran.ru/exarray

    Copyright 1998-2003, ..஢,   PAH.
    All Rights Reserved.

     ।⠢  ᫮ 業 "public domain",
    .. ᪠ ᢮ ਬ, 䨪 
    ࠭   ᫮ ࠭ ࠩ
      ᢥ   ᥭ .

           .
        "AS IS"  - 
         .
-------------------------------------------------------------- */
#include <assert.h>     /* Header file for assert function */
#include <malloc.h>     /* Header file for standard allocation functions */
#include <memory.h>     /* Header file for standard memory functions */
#include <stdlib.h>     /* Header file for standard functions */
#define EXALLOC_OUT_OF_LINE
#include "Exarray.h"

/* --------------------------------------------------------------
    ஢塞 প ࠢ.
-------------------------------------------------------------- */

#ifndef _mm_malloc
#define _aligned_malloc(p,b,a)  malloc(b)
#define _aligned_realloc(p,b,a) realloc(p,b)
#define _aligned_free(p)        free(p)
#endif/*_mm_malloc*/

/* --------------------------------------------------------------
    譨 뫪 ,  "C", ⮡
    ஢ ८ࠧ .
      ७ ꥪ 㫨
     ࠧ묨 ﬨ ஢.
-------------------------------------------------------------- */

#ifdef  __cplusplus
extern "C" {
#endif/*__cplusplus*/

/* --------------------------------------------------------------
    誠 ᪮ ᨢ  ᢠ
    ᪨ 㪠⥫ 祭 NULL.
-------------------------------------------------------------- */

struct  exblock_t VDECL exnull_c;

/* --------------------------------------------------------------
    㭪 set_exalloc_handler() ⠭
    ࠡ稪 訡 । ,
     set_new_handler().

    ࠬ:
    pvf     ⥫  㭪 ⨯ void name (void) 
            NULL ᫨  ࠡ⪨ 訡 ᫥ 맢
            (*exalloc_status.size_handler)();

    뤠: ।騩 㪠⥫.
-------------------------------------------------------------- */

void (* set_exalloc_handler (void (*pvf) (void))) (void)
{
    static void (* pvfFailHandler)(void) = NULL;
    void (*pvfPrev) (void) = pvfFailHandler;
    pvfFailHandler = pvf;
    return pvfPrev;
}

/* --------------------------------------------------------------
    㭪 exalloc_size_fail() 뢠 ࠡ稪 訡
    ।    ,    ࠢ NULL,
    ⥬ 뢠 abort().
-------------------------------------------------------------- */

void exalloc_size_fail (void)
{
    for (;;)
    {
        void (*pvf) (void) = set_exalloc_handler (NULL);
        set_exalloc_handler (pvf);
        if (pvf == NULL) break;
        (*pvf)();
    }
    abort();
}

/* --------------------------------------------------------------
    㭪 exalloc_stub()   祣.
-------------------------------------------------------------- */

void exalloc_stub (void) {}

/* --------------------------------------------------------------
    㭪 exalloc_null_fail() 뢠 abort.
-------------------------------------------------------------- */

static void exalloc_null_fail (void)
{
    #define NULL_POINTER_INDIRECTION 0
    assert (NULL_POINTER_INDIRECTION);
    abort();
}

/* --------------------------------------------------------------
    㭪 exalloc_range_fail() 뢠 abort.
-------------------------------------------------------------- */

static void exalloc_range_fail (void)
{
    #define INDEX_RANGE_ERROR 0
    assert (INDEX_RANGE_ERROR);
    abort();
}

/* --------------------------------------------------------------
    ࠡ稪  訡  ᢥ
    o । .

    ⥫ 㭪樨, 뢠  ࠭
    訡 । . 㭪  㤨
    ᪫祭  ४ ࠡ ணࠬ.

    ⥫ ᪮ 㭪樨, 뢠
     ⮬᪮ 㢥祭 ࠧ ᨢ
     NULL, ᫨ 맮 ᪮ 㭪樨
     ॡ.  ਬ  ஢
    ⮬᪮ 㢥祭 ࠧ.

    ⥫ 㭪樨, 뢠  饭
     NULL-㪠⥫. 㭪  㤨
    ᪫祭  ४ ࠡ ணࠬ.

    ⥫ 㭪樨, 뢠  室
      ࠭ ᨢ  ⮬ 砥, ᫨
     ।ᬮ७ ⮬᪮ 㢥祭
    ࠧ ᨢ. 㭪  㤨
    ᪫祭  ४ ࠡ ணࠬ.
-------------------------------------------------------------- */

struct exalloc_status_t VDECL exalloc_status =
    { exalloc_size_fail, exalloc_stub,
      exalloc_null_fail, exalloc_range_fail,
      0, 0, 0, 0 };

/* --------------------------------------------------------------
    㭪 exmalloc 뤥  ,
     ﬨ.

     ९ ࠧ來 ⪨ 
    墠⪥  뢠 ࠡ稪 訡,
    ⠭  exalloc_set_handler, 
    ᢮ exalloc_status.size_handler.

    ࠬ:
    blocksize          .

    뤠:         ⥫    NULL.
-------------------------------------------------------------- */

void*   FCDECL  exmalloc (size_t blocksize)
{
    void* p = NULL;
    exaligned_mrealloc (&p, blocksize, 1, 0, blocksize);
    return (p);
}

/* --------------------------------------------------------------
    㭪 exaligned_malloc 뤥 ஢
     ,  ﬨ.

     ९ ࠧ來 ⪨ 
    墠⪥  뢠 ࠡ稪 訡,
    ⠭  exalloc_set_handler, 
    ᢮ exalloc_status.size_handler.

    ࠬ:
    blocksize          .
    blockalign      ࠢ    (2**n).

    뤠:         ⥫    NULL.
-------------------------------------------------------------- */

void*   FCDECL  exaligned_malloc (size_t blocksize, size_t blockalign)
{
    void* p = NULL;
    exaligned_mrealloc (&p, blocksize, blockalign, 0, blocksize);
    return (p);
}

/* --------------------------------------------------------------
    㭪 exmrealloc() 뤥, 㤫,
    㪮稢  ᢮  ,
     ⠪   ⮪.

     ९ ࠧ來 ⪨ 
    墠⪥  뢠 ࠡ稪 訡,
    ⠭  exalloc_set_handler, 
    ᢮ exalloc_status.size_handler.

    ࠬ:
    p                㪠⥫ .
                    *p == NULL  ।.
                    *p != NULL  ।.
                    祭 *p .
    blocksize        ࠧ   0
                    ᫨    ᢮.
    memset_start    砫  㫥.
    memset_stop       㫥 ( ).
-------------------------------------------------------------- */

void    FCDECL  exmrealloc (void** p, size_t blocksize,
                 size_t memset_start, size_t memset_stop)
{
    exaligned_mrealloc (p, blocksize, 1, memset_start, memset_stop);
}

/* --------------------------------------------------------------
    㭪 exaligned_mrealloc() 뤥, 㤫,
    㪮稢  ᢮ ஢  ,
     ⠪   ⮪.

     ९ ࠧ來 ⪨ 
    墠⪥  뢠 ࠡ稪 訡,
    ⠭  exalloc_set_handler, 
    ᢮ exalloc_status.size_handler.

    ࠬ:
    p                㪠⥫ .
                    *p == NULL  ।.
                    *p != NULL  ।.
                    祭 *p .
    blocksize        ࠧ   0
                    ᫨    ᢮.
    blockalign      ࠢ    (2**n).
    memset_start    砫  㫥.
    memset_stop       㫥 ( ).
-------------------------------------------------------------- */

void    FCDECL  exaligned_mrealloc (void** p,
                 size_t blocksize, size_t blockalign,
                 size_t memset_start, size_t memset_stop)
{
    void* pp = *p;                /* 祭 p */

    /* 뤥 , ᫨ blocksize != 0 */

    if (blocksize)
    {
        /* ()ࠧ   ஢ १ */

        while (blocksize > EXCALCBLOCKSIZE_MAX - blockalign ||
              (pp = _aligned_realloc (*p, blocksize, blockalign))
              == NULL)
        {
            /* 맢 ࠡ稪 訡 ।
                 த ⪨ ࠧ饭 */

            void (*pvf) (void) = set_exalloc_handler (NULL);
            set_exalloc_handler (pvf);
            if (pvf != NULL) { (*pvf)(); continue; }

            /* 맢 ࠡ稪 ࠭ 訡
               ।    */

            (*exalloc_status.size_handler)();
            exalloc_status.nBlocksFailed++;
            return;
        }

        /* ஢ ࠢ */

        if (((size_t)pp & (blockalign - 1)) != 0) {}

        /*  ᫮ ࠧ饭  */

        if (pp != NULL)
        {
            exalloc_status.nBlocksAllocated++;
        }

        /* 樠 */

        if (memset_stop > memset_start)
        {
             memset ((char*)pp + memset_start, 0,
                   memset_stop - memset_start);
        }

        /*  ଠ  뤥  */

        if (exalloc_status.pMinAlloc - 1 >= (char*) pp)
        {
            exalloc_status.pMinAlloc = (char*)pp;
        }
        if (exalloc_status.pMaxAlloc < (char*)pp + blocksize)
        {
            exalloc_status.pMaxAlloc = (char*)pp + blocksize;
        }
    }

    /* ᢮  ᫨ blocksize == 0  *p != NULL */

    else if (pp)
    {
        _aligned_free (pp); pp = NULL;
        exalloc_status.nBlocksAllocated--;
    }

    /*  *p */

    *p = pp;
}

/* --------------------------------------------------------------
    㭪 exfree() ᢮  .

    ࠬ:
    p              NULL.
-------------------------------------------------------------- */

void    FCDECL  exfree (void* p)
{
    exaligned_free (p);
}

/* --------------------------------------------------------------
    㭪 exaligned_free() ᢮
    ஢  .

    ࠬ:
    p              NULL.
-------------------------------------------------------------- */

void    FCDECL  exaligned_free (void* p)
{
    if (p)
    {
        _aligned_free (p);
        exalloc_status.nBlocksAllocated--;
    }
}

/* --------------------------------------------------------------
    㭪 exrange() 뢠 exalloc_status.null_handler
     exalloc_status.range_handler  ᨬ  p.

    ࠬ:
    p              NULL.
-------------------------------------------------------------- */

void    FCDECL  exrange (void* p)
{
    if (p == NULL)
            (*exalloc_status.null_handler)();
    else    (*exalloc_status.range_handler)();
}

/* --------------------------------------------------------------
    㭪 excalcblocksize() 뢠
    ⨬ ࠧ    ,
         ॡ㥬.

    砫 ࠧ EXCALCBLOCKSIZE_MOD
    । 㬭  2  1.5, 
    ⠭  襭.
     㬥襭 ࠣ樨 ᪮
       뢠 ࠧ
    ⥬  EXCALCBLOCKSIZE_SYS,
    祭 EXCALCBLOCKSIZE_MOD 
     64**n +/- 16, ⮬ १
     㤥 ⭠ 16  32,   64.

    ᫨ 襭 ࠧ ᫨誮 ,
     뤠 EXSIZE_T_MAX.

    ࠬ:
    blocksize        ࠧ   .

    뤠:         ⨬ ࠧ   
                    EXSIZE_T_MAX.
-------------------------------------------------------------- */

size_t  FCDECL  excalcblocksize (size_t blocksize)
{
    size_t n = EXCALCBLOCKSIZE_MOD, k = 0;

    for (;; k = ~k, (k? (n <<= 1): (n += (n >> 1))))
    {
        n -= EXCALCBLOCKSIZE_SYS; if (n >= blocksize) break;
        n += EXCALCBLOCKSIZE_SYS; if ((int) n < 0)
                               { n = EXSIZE_T_MAX; break; }
    }

    return (n);
}

/* --------------------------------------------------------------
    㭪 exmuladd()  s*n+k
     । 0..EXSIZE_T_MAX.
-------------------------------------------------------------- */

size_t  FCDECL  exmuladd (size_t s, size_t n, size_t k)
{
    return ((n <= (EXSIZE_T_MAX - k) / s)? (n * s + k): EXSIZE_T_MAX);
}

/* --------------------------------------------------------------
    㭪 exmul()  s*n
     । 0..EXSIZE_T_MAX.
-------------------------------------------------------------- */

size_t  FCDECL  exmul (size_t s, size_t n)
{
    return ((s == 1)? n: (n <= EXSIZE_T_MAX / s)? n * s: EXSIZE_T_MAX);
}

/* --------------------------------------------------------------
    㭪 exadd()  n+k
     । 0..EXSIZE_T_MAX.
-------------------------------------------------------------- */

size_t  FCDECL  exadd (size_t n, size_t k)
{
    return ((n <= EXSIZE_T_MAX - k)? (n + k): EXSIZE_T_MAX);
}

/* --------------------------------------------------------------
    㭪 exchkadd()  n+k  । 0..max,
     뢠 ࠡ稪 訡,
    ᢮ exalloc_status.size_handler.
-------------------------------------------------------------- */

size_t  FCDECL  exchkadd (size_t n, size_t k, size_t max)
{
    if (n > max - k) (*exalloc_status.size_handler)();
    return (n + k);
}

#ifdef  __cplusplus
}
#endif/*__cplusplus*/
