/*	fname.h

	樨   䠩  ଠ MS-DOS/Windows.

	(C) ..஢,   PAH, 1992 - 1999
	All Rights Reserved.
*/
#ifndef _FNAME_H
#define _FNAME_H

#include <string.h>

#ifndef _BSTRING_H
#include <bstring.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

// =========================================================================
//	  㦥 ६.
//	樨  㭪権    !
// =========================================================================
extern		bstring	VDECL	_fname;		//    䠩.
extern  const	char	VDECL	szENLONG [];	//  ᫨誮 .
extern  	char*	VDECL	pszfns_start;	//  砫 ⠭.

// =========================================================================
//	  饭  bstring-㭪  .
// =========================================================================
//	 㭪樨.
#define fnmax()		bsmax(_fname)
#define fnlen()		bslen(_fname)
#define fnval()   	bsval(_fname)
#define fnterm()	bsterm(_fname)
#define fnleft()	bsleft(_fname)

//	c㬥⠫ 㭪樨.
#define _fnmax()	_bsmax(_fname)
#define _fnlen()	_bslen(_fname)

//	-㭪 (  㪠⥫)
#define FNDIF(p)	PDIF (p, fnval())

//	ࠢ ⠭.
#define fns_start(s)	(pszfns_start = (s))

// =========================================================================
//	⠪᪨ 㭪樨.
// =========================================================================
//	।,   䠩 ⮨  易⥫쭮  ᪠
//	c 稥, 易⥫쭮 ᨬ ୥ ४ਨ '\' 
//	易⥫쭮 ᫥⥫쭮 , ࠧ '\'.
//	᫨  ⮨    ᪠  蠥 '\', 
//	᫥  ⠥ ⮩.
//	 㭪樨, ஬ ᪠,  㪠⥫  ப.
//	fndir 頥 㪠⥫    ,  fnterm(),
//	fnfile 頥 㪠⥫  ᫥ ,  fnterm(),
//	fnfchr 頥 㪠⥫   ᨬ,  fnterm().
//	 ९  뢠 exprinterror.
//	 㭪樨, ஬ fnfc*,  ॡ 0 - ࠭祭.
//	 㭪樨, ஬ ᪠, ⠭ 0 - ࠭祭.
//	   १ࢭ ᨬ, ⮬ ᪠ ᢠ
//	祩 fnterm [1]  fnval() [fnmax() + 1].

//	஢.
char*	EXDECL	fncpy	(const char* src);	     //  砫.
char*	EXDECL	fnlcpy	(size_t l, const char* src); // 稭  樨 l.
char*	EXDECL	fncat	(const char* src);	     //  .

//	ࠡ⪠ ᫥ .
char*	EXDECL	fnfile	(void);			     // .
char*	EXDECL	fnfset	(const char* src);	     // .
char*	EXDECL	fnfadd	(const char* src);	     // .
char*	EXDECL	fnfdel	(void);			     // 祭.

//	ࠡ⪠ ७ ᫥ .
char*	EXDECL	fnfchr	(int c);		     //  ᨬ.
char*	EXDECL	fnfcset	(int c, const char* src);    // , 稭 .
char*	EXDECL	fnfcadd	(int c, const char* src);    // , ᫨ .
char*	EXDECL	fnfcdel	(int c);		     // 祭, 稭 .

//	ଠ  믮, ᫨    ᥬ⨪.
char*	EXDECL	fnfadd0	(void);			//   '\'.
char*	EXDECL	fnfdel0	(void);			//   '\'  '.'.

// =========================================================================
//	⠪᪨ 㭪樨  ⠭.
// =========================================================================
//	⠭ sub  src 믮 ⭮ ᫥ ࠢ
//	  ࠢ, ..  '*'  '?'  ⮬ '.'
//	᫨ fns_mode (FNS_MATCH),  ⠭  src   ࢮ '*?'.
//	⥫   src: ',' 㤠 ⠢塞 ᨬ, 
//	';' 뢠 ⠭  sub  砫.
//	騥   sub  묨, 譨 ;
//	⠭  ᪠  믮.

//	஢.
char*	EXDECL	fncpys	(const char* src, const char *sub);
char*	EXDECL	fnlcpys	(size_t l, const char* src, const char *sub);
char*	EXDECL	fncats	(const char* src, const char *sub);

//	ࠡ⪠ ᫥ .
char*	EXDECL	fnfsets	(const char* src, const char *sub);
char*	EXDECL	fnfadds	(const char* src, const char *sub);

//	ࠡ⪠ ⥩ ᫥ .
char*	EXDECL	fnfcsets (int c, const char* src, const char *sub);
char*	EXDECL	fnfcadds (int c, const char* src, const char *sub);

// =========================================================================
//	⠪᪨ 㭪樨  ⠭ ࠢ.
// =========================================================================
//	⠭ sub  src 믮 ⭮ ࠢ 
//	  ࠢ, ..  '*'  '?'  ⮬ '.'
//	᫨ fns_mode (FNS_MATCH),  ⠭  src   ࢮ '*?'.
//	⥫   src: ',' 㤠 ⠢塞 ᨬ, 
//	';' 뢠 ⠭  sub  砫.
//	騥   sub  묨, 譨 ;
//	⠭  ᪠  믮.

//	஢.
char*	EXDECL	fncpysr	 (const char* src, const char *sub);
char*	EXDECL	fnlcpysr (size_t l, const char* src, const char *sub);
char*	EXDECL	fncatsr	 (const char* src, const char *sub);

//	ࠡ⪠ ᫥ .
char*	EXDECL	fnfsetsr (const char* src, const char *sub);
char*	EXDECL	fnfaddsr (const char* src, const char *sub);

//	ࠡ⪠ ⥩ ᫥ .
char*	EXDECL	fnfcsetsr (int c, const char* src, const char *sub);
char*	EXDECL	fnfcaddsr (int c, const char* src, const char *sub);

// =========================================================================
//	UNC-।.
// =========================================================================
char*	EXDECL	unc_dir       (const char *unc);	// ࢠ .
int	EXDECL	unc_dir_count (const char *unc);	// ᫮ .
char*	EXDECL	unc_dir_right (const char *unc, int n);	//  n ࠢ.

#ifdef __cplusplus
}
#endif

//	 -㭪権.
#define	fncpy(src)		(_fnlen() = 0,   fncat   (src))
#define	fncpys(src,sub)		(_fnlen() = 0,   fncats  (src, sub))
#define	fncpysr(src,sub)	(_fnlen() = 0,   fncatsr (src, sub))
#define	fnlcpy(l,src)		(_fnlen() = (l), fncat   (src))
#define	fnlcpys(l,src,sub)	(_fnlen() = (l), fncats  (src, sub))
#define	fnlcpysr(l,src,sub)	(_fnlen() = (l), fncatsr (src, sub))

#define	fnfset(src)		fnlcpy   (FNDIF (fnfile()), src)
#define	fnfsets(src,sub)	fnlcpys  (FNDIF (fnfile()), src, sub)
#define	fnfsetsr(src,sub)	fnlcpysr (FNDIF (fnfile()), src, sub)
#define	fnfadd(src)		(fnfadd0(), fncat   (src))
#define	fnfadds(src,sub)	(fnfadd0(), fncats  (src,sub))
#define	fnfaddsr(src,sub)	(fnfadd0(), fncatsr (src,sub))
#define fnfdel()		(_fnlen() = FNDIF (fnfile()), fnfdel0())
#define fnfcset(c,src)       fnlcpy   (FNDIF (fnfchr (c)), src)
#define fnfcsets(c,src,sub)  fnlcpys  (FNDIF (fnfchr (c)), src, sub)
#define fnfcsetsr(c,src,sub) fnlcpysr (FNDIF (fnfchr (c)), src, sub)
#define fnfcadd(c,src)       (strchr (fnfile(),c)? fnval(): fncat   (src))
#define fnfcadds(c,src,sub)  (strchr (fnfile(),c)? fnval(): fncats  (src, sub))
#define fnfcaddsr(c,src,sub) (strchr (fnfile(),c)? fnval(): fncatsr (src, sub))
#define fnfcdel(c)	  (fnval() [_fnlen() = FNDIF (fnfchr(c))] = 0, fnval())

#endif
