/*      exalloc.c

        ।   ࠡ⪮ 訡  㫥 ᨢ.

        (C) ..஢,   PAH, 1994 - 2002
        All Rights Reserved.
*/
//#define EXTRACE
#include <malloc.h>
#include <memory.h>
#include <exalloc.h>
#include <exhandle.h>

void*   FCDECL  exmalloc (size_t blocksize)     // 뤥 .
{
  void* pp;
#ifdef  EXTRACE
  exprintf ("exmalloc(%10u)=", blocksize);
#endif
  if (blocksize == 0) blocksize = 1;            // 㫥  (  new).
  errno = 0;
  while (blocksize > EXCALCBLOCKSIZE_MAX 
     || (pp = malloc (blocksize)) == NULL)      // 訡 ࠧ饭.
  { 
    exalloc_blocksize = blocksize;
    if (exalloc_fail_handle() == 0) return (NULL);
  }
#ifdef  EXTRACE
  exprintf ("%p, coreleft=%lu\n", pp, (unsigned long) excoreleft());
#endif
  return ((void*) memset (pp, 0, blocksize));
}

void    FCDECL  exfree (void* p)                // ᢮ .
{
#ifdef  EXTRACE
  exprintf ("coreleft=%lu, exfree(%p), ", (unsigned long) excoreleft(), p);
#endif
  if (p) free (p);
#ifdef  EXTRACE
  exprintf ("coreleft=%lu\n", (unsigned long) excoreleft());
#endif
}
