/*      excalcs.c

         ⨬쭮 ࠧ ᨢ.

        (C) ..஢,   PAH, 1999 - 2002
        All Rights Reserved.
*/
#include <exalloc.h>

/* --------------------------------------------------------------
    㭪 excalcblocksize() 뢠
    ⨬ ࠧ    ,
         ॡ㥬.

    砫 ࠧ EXCALCBLOCKSIZE_MOD
    । 㬭  2  1.5, 
    ⠭  襭.
     㬥襭 ࠣ樨 ᪮
       뢠 ࠧ
    ⥬  EXCALCBLOCKSIZE_SYS,
    祭 EXCALCBLOCKSIZE_MOD 
     64**n +/- 16, ⮬ १
     㤥 ⭠ 16  32,   64.

    ᫨ 襭 ࠧ ᫨誮 ,
     뤠 EXSIZE_T_MAX.

    ࠬ:
    blocksize        ࠧ   .

    뤠:         ⨬ ࠧ   
                    EXSIZE_T_MAX.
-------------------------------------------------------------- */

size_t  FCDECL  excalcblocksize (size_t blocksize)
{
    size_t n = EXCALCBLOCKSIZE_MOD, k = 0;

    for (;; k = ~k, (k? (n <<= 1): (n += (n >> 1))))
    {
        n -= EXCALCBLOCKSIZE_SYS; if (n >= blocksize) break;
        n += EXCALCBLOCKSIZE_SYS; if ((int) n < 0)
                               { n = EXSIZE_T_MAX; break; }
    }

    return (n);
}
