/*	exio_.c

	㭪樨 筮 -뢮  ࠡ⪮ 訡.

	(C) ..஢,   PAH, 1992 - 1999
	All Rights Reserved.
*/
#include <io.h>
#include <sys\stat.h>
#include <exio.h>
#include <exhandle.h>

int	STDECL	exopen	(	// ⨥ 䠩.
	const	char*	path,	//  䠩.
		int	mode	//  .
	)			// 頥 ਯ.
{
  if (excatch) { _exfind = 0; return (-1); }
  errno = 0;
  return (exopen_handle (open (path, mode, S_IREAD | S_IWRITE), path, mode));
}

int	STDECL	_exread	(  	// ⥭ .
		int	fd,	// ਯ.
		void*	buf,	// .
		size_t	len	//  .
	)			// 頥   ( >=0 ).
{
  if (exread_handle (fd))
  {
    register int count = read (fd, buf, len);

    if (count != -1) return (count);
    exread_fail_handle (fd);
  }
  return (0);
}

int	STDECL	exwrite	(	//  .
		int	fd,	// ਯ.
	const	void*	buf,	// .
		size_t	len	//   ( >=0 ).
	)
{
  if (exwrite_handle (fd))
  {
    register int count = write (fd, (void *)buf, len);

    if (count == -1) exwrite_fail_handle (fd);
    if ((size_t) count != len) exwrite_full_handle (fd);
  }
  return (len);
}

void	STDECL	exclose	( 	// ⨥.
		int	 fd	// ਯ.
	)
{
  if (exclose_handle (fd) && close (fd)) exclose_fail_handle (fd);
}
