/*      exmuladd.c

          ᫮  ९ ࠧ來 ⪨.

        (C) ..஢,   PAH, 1999 - 2002
        All Rights Reserved.
*/
#include <exalloc.h>

/* --------------------------------------------------------------
    㭪 exmuladd()  s*n+k
     । 0..EXSIZE_T_MAX.
-------------------------------------------------------------- */

size_t  FCDECL  exmuladd (size_t s, size_t n, size_t k)
{
    return ((n <= (EXSIZE_T_MAX - k) / s)? (n * s + k): EXSIZE_T_MAX);
}

/* --------------------------------------------------------------
    㭪 exmul()  s*n
     । 0..EXSIZE_T_MAX.
-------------------------------------------------------------- */

size_t  FCDECL  exmul (size_t s, size_t n)
{
    return ((s == 1)? n: (n <= EXSIZE_T_MAX / s)? n * s: EXSIZE_T_MAX);
}

/* --------------------------------------------------------------
    㭪 exadd()  n+k
     । 0..EXSIZE_T_MAX.
-------------------------------------------------------------- */

size_t  FCDECL  exadd (size_t n, size_t k)
{
    return ((n <= EXSIZE_T_MAX - k)? (n + k): EXSIZE_T_MAX);
}

/* --------------------------------------------------------------
    㭪 exchkadd()  n+k  । 0..max.
     ९ ࠧ來 ⪨ 
    墠⪥  뢠 ࠡ稪 訡,
    ᢮ exalloc_status.size_handler.
-------------------------------------------------------------- */

size_t  FCDECL  exchkadd (size_t n, size_t k, size_t max)
{
    if (n > max - k) (*exalloc_status.size_handler)();
    return (n + k);
}
