/*
ͻ
     㭪樨 ਧ 뢮 PCX - 䠩  ᯫ     
                ᮯ஢ ⥪⮢ ப.                
                       (C) =SVSoft=                              
	  * ᪨ ..,   ,  1993.*           
	  * ஢ ..,    , 1993 - 1999. *           
          ࠧࠡ⪥ ᯮ짮  PCXLIB            
		     GENUS Microprogramming INC                   
ͼ
*/
#ifdef	__TURBOC__
#ifndef __FLAT__
#include <pcxlib.h>
#include <stddef.h>
#include <memory.h>
#include <dos.h>
#include <spk_fun.h>
#include <pcx_fun.h>

static unsigned char pal   [48];	//   ᯫ.
static unsigned char clrma [48];	//  .
static unsigned char stdclrma [] =	// ⠭ .
      { 0x00, 0x00, 0x00, 0x60,			// CGA
	0x00, 0x00, 0x00,			// EGA / VGA
	0x00, 0x00, 0xAA,
	0x00, 0xAA, 0x00,
	0x00, 0xAA, 0xAA,
	0xAA, 0x00, 0x00,
	0xAA, 0x00, 0xAA,
	0xAA, 0x55, 0x00,
	0xAA, 0xAA, 0xAA,
	0x55, 0x55, 0x55,
	0x55, 0x55, 0xFF,
	0x55, 0xFF, 0x55,
	0x55, 0xFF, 0xFF,
	0xFF, 0x55, 0x55,
	0xFF, 0x55, 0xFF,
	0xFF, 0xFF, 0x55,
	0xFF, 0xFF, 0xFF };

short	cdecl	PcxDisplay [] = {
	pcxCGA_4,	pcxCGA_6,
	pcxEGA_D,	pcxEGA_E,	pcxEGA_F,	pcxEGA_10,
	pcxVGA_11,	pcxVGA_12,	pcxVGA_13,	pcxHERC	};
short	cdecl	PcxHres [] = {
	320,		640,
	320,		640,		640,	       	640,
	640,		640,		320,		720	};
short	cdecl	PcxVres [] = {
	200,		200,
	200,		200,		350,	       	350,
	480,		480,		200,		348	};

short	cdecl	PcxMode	= -1;		//  ᯫ.
//	pcxTEXT				// ⮢.
//	pcxGRAPHICS			// ⮢  ᪨.
//	-1 				//   ⠭.
short	cdecl	PcxDelay = 200;		// প  ᬥ ० ().

/*-------------------------------------------------------------
    । ⨯  (⪫祭).
--------------------------------------------------------------*/
/*
int	pascal	CheckVideoInfo (void)
{
  PCXVINFO vi[2];
  pcxVideoInfo(vi);
  if (vi[0].display != viMDAdisp) PcxDisplay [pcxEGA_F] = pcxEGA_F;
  return vi[0].adapter;
}
*/
/*-------------------------------------------------------------
    ⥭  pcx-䠩  ,
    । ࠧ஢ ࠦ.
--------------------------------------------------------------*/
int	pascal	ReadPcxHdr (PSCREEN *buf, char *PcxFileName)
{
  int retcode;

  if ((retcode = pcxGetFileHeader (PcxFileName, &(buf->h))) != pcxSUCCESS)
    return retcode;
  if (buf->h.manuf != 10) return pcxERR_NOTPCX;

  buf->vptr	= 0L;
  buf->xsize	= buf->h.x2 - buf->h.x1 + 1;
  buf->ysize	= buf->h.y2 - buf->h.y1 + 1;
  buf->color	= buf->h.nplanes * buf->h.bitpx;
  buf->pal_pres = (buf->h.hard != 3) && (buf->color > 1);

  buf->fmode = buf->dmode =
  (buf->h.bitpx == 2)						? pcxCGA_4:
  (buf->h.hres <= 320 && buf->h.vres <= 200 && buf->color <= 4) ? pcxEGA_D:
  (buf->h.hres <= 640 && buf->h.vres <= 200 && buf->color == 1) ? pcxCGA_6:
  (buf->h.hres <= 640 && buf->h.vres <= 200 && buf->color <= 4) ? pcxEGA_E:
  (buf->h.hres <= 640 && buf->h.vres <= 350 && buf->color == 1) ? pcxEGA_F:
  (buf->h.hres <= 640 && buf->h.vres <= 350 && buf->color <= 4) ? pcxEGA_10:
//(buf->h.hres <= 640 && buf->h.vres <= 480 && buf->color == 1) ? pcxVGA_11:
//(buf->h.hres <= 640 && buf->h.vres <= 480 && buf->color <= 4) ? pcxVGA_12:
//(buf->h.hres <= 320 && buf->h.vres <= 200 && buf->color <= 8) ? pcxVGA_13:
  (buf->h.hres == 720 && buf->h.vres == 348 && buf->color == 1) ? pcxHERC:
  (buf->color == 1) ? pcxVGA_11:
  (buf->color <= 4) ? pcxVGA_12:
  (buf->color <= 8) ? pcxVGA_13:
    pcxERR_BADDISP;

  if (buf->fmode < 0)	return (pcxERR_BADDISP);
  if (buf->fmode >= 0)	buf->dmode = PcxDisplay [buf->fmode];
  if (buf->dmode < 0)	return (pcxERR_BADMODE);

  if (buf->pal_pres && buf->color > 4)
    retcode = pcxGetFilePalette (buf->dmode, PcxFileName, buf->pal);

  return (retcode);
}

/*--------------------------------------------------------------
   㧪 pcx-ࠦ  㠫 .
---------------------------------------------------------------*/
int	pascal	ReadPcxImg (PSCREEN *buf, char *PcxFileName)
{
  int retcode;

  if (buf->vptr)	return (pcxSUCCESS);		//   ⮩.
  if (buf->fmode < 0)	return (pcxERR_BADMODE);

  if ((retcode = pcxCreateVirtual (pcxCMM, &(buf->vptr), buf->fmode,
		(buf->xsize + 31) & 0xFFE0, buf->ysize)) != pcxSUCCESS)
  {	      	// 㣫   ⭮ 32 ࠭ 訡  pcxlib.
    buf->vptr = NULL;
    return (retcode);
  }
  if ((retcode = pcxFileVirtual (PcxFileName, buf->vptr)) != pcxSUCCESS)
    buf->vptr = NULL;

  return (retcode);
}

/*---------------------------------------------------------------
   뢮 ࠦ  .   ᯫ.
-----------------------------------------------------------------*/
int	pascal	ShowPcxImg (PSCREEN *buf, char *PcxFileName)
{
  int retcode;
  int sp = buf->pal_pres;		//  ⠭ .
  int delay = 0;			// প.
  struct time timer;			// .

  if (buf->dmode < 0) return (pcxERR_BADMODE);
  if (PcxDelay && (PcxMode < 0 ||
      buf->dmode != ((PcxMode == pcxTEXT) ? pcxVGA_13: pcxGetDisplay())))
  {
    delay = PcxDelay; gettime (&timer);
  }
  if (buf->dmode == pcxCGA_6 || buf->dmode == pcxHERC)	//   ०
    sp = 0;				//  ࠡ뢠 ୮!
  else if (buf->color <= 4)		// ࠢ   ᪮७.
  {
    unsigned char *pc = stdclrma + ((buf->dmode == pcxCGA_4)? 0: 4);

    if (PcxMode <= pcxTEXT || buf->dmode != pcxGetDisplay())
    {					//   - ⠭⭠.
      memcpy (clrma, pc, 48); pcxDecodePalette (buf->dmode, clrma, pal);
    }

    if (sp) pc = buf->h.clrma;		// ࠦ  ᢮ .
    if (buf->color == 1)
      memcpy (clrma, pc, 3), memcpy (clrma + 45, pc + (sp ? 3: 45), 3);
    else
      memcpy (clrma, pc, 48);

    if (buf->dmode >= pcxEGA_D && buf->dmode <= pcxEGA_10)
    {						// ४ 訡
      register unsigned char *pc;		// pcxDecodePalette.
      register int c;
      for (pc = clrma; pc < clrma + 48; pc++)
      {
	c = *pc & 0xC0; c = c | (c >> 2); *pc = c | (c >> 4);
      }
    }
    pcxDecodePalette (buf->dmode, clrma, buf->pal);
    if ((sp = memcmp (pal, buf->pal, 48)) != 0) memcpy (pal, buf->pal, 48);
  }
//
//	뢮 ࠦ.
//
  if ((retcode = pcxSetDisplay (buf->dmode)) != pcxSUCCESS) return (retcode);
//if (buf->dmode == pcxHERC &&
//    (retcode = pcxSetHerc   (pcxHERChalf)) != pcxSUCCESS) return (retcode);
  if ((retcode = pcxSetMode   (pcxGRAPHICS)) != pcxSUCCESS)
  {
    if ((retcode = pcxSetDisplay (pcxCGA_6)) != pcxSUCCESS) return (retcode);
    if ((retcode = pcxSetMode (pcxGRAPHICS)) != pcxSUCCESS)
    {
      EndGraphics(); return (retcode);
    }
    sp = 0;
  }
  
  PcxMode = pcxGRAPHICS;
  if (sp && (retcode = pcxSetDisplayPalette (buf->pal)) != pcxSUCCESS)
							    return (retcode);
  if ( (buf->xmax = PcxHres [buf->dmode] - 1) > buf->h.x2)
	buf->xmax = buf->h.x2;
  if ( (buf->ymax = PcxVres [buf->dmode] - 1) > buf->h.y2)
	buf->ymax = buf->h.y2;
  if (delay) while (GetTimer (&timer) < (long) delay);	// প.
  retcode = (buf->vptr) ?
    pcxVirtualDisplay (buf->vptr, 0, 0, buf->h.x1, buf->h.y1,
					buf->xmax, buf->ymax, 0):
    pcxFileDisplay (PcxFileName, buf->h.x1, buf->h.y1, 0);

  return (retcode);
}
//    if ((retcode = pcxBeginPaletteGrab (stdpal)) == pcxSUCCESS)
//    {
//      retcode = pcxSetMode (pcxGRAPHICS);
//      pcxGetDisplayPalette (curpal);
//      pcxEndPaletteGrab();
//    }
//    if (retcode != pcxSUCCESS) return retcode;

/*---------------------------------------------------------------
   뢮 ࠦ  .   ᯫ.
-----------------------------------------------------------------*/
/*    ࠡ⠥  ࠭ >64K - 訡  pcxGetImage.
int	pascal	SavePcxImg (PSCREEN *buf)
{
  int retcode;

  if (buf->dmode < 0)	return (pcxERR_BADMODE);
  if (buf->h.x1 == 0 && buf->h.x2 >= PcxHres [buf->dmode] - 1 &&
      buf->h.y1 == 0 && buf->h.y2 >= PcxVres [buf->dmode] - 1)
			return (pcxSUCCESS);
  FreePcxImg (buf);
  if ((retcode = pcxCreateVirtual (pcxCMM, &(buf->vptr), buf->dmode,
		(PcxHres [buf->dmode] + 31) & 0xFFE0, PcxVres [buf->dmode])
		) != pcxSUCCESS)
  {	      	// 㣫   ⭮ 32 ࠭ 訡  pcxlib.
    buf->vptr = NULL;
    return (retcode);
  }
  if ((retcode = pcxGetImage ( buf->vptr,
			buf->h.x1 = 0,
			buf->h.y1 = 0,
			buf->h.x2 = PcxHres [buf->dmode] - 1,
			buf->h.y2 = PcxVres [buf->dmode] - 1, 0)
		) != pcxSUCCESS) buf->vptr = NULL;

  return (retcode);
}
*/
/*------------------------------------------------------------------
   襭 .   ᢮  㪠⥫.
------------------------------------------------------------------*/
int	pascal	FreePcxImg (PSCREEN *buf)
{
   if (buf->vptr)
   {
     pcxDestroyVirtual (buf->vptr);
     buf->vptr = NULL;
     return (1);
   }
   return (0);
}

/*---------------------------------------------------------------------
   室  ⥪⮢ ०.
-----------------------------------------------------------------------*/
void	pascal	EndGraphics (void)
{
  if (PcxMode != pcxTEXT) pcxSetMode (PcxMode = pcxTEXT);
}

/*---------------------------------------------------------------------
    ६饭 ⥪饩 樨.
-----------------------------------------------------------------------*/
void	pascal	movetoxy (int x, int y)
{
  union REGS regs;

  regs.h.ah = 2;  /* set cursor postion */
  regs.h.dh = y;
  regs.h.dl = x;
  regs.h.bh = 0;  /* video page 0 */
  int86 (0x10, &regs, &regs);
}

/*---------------------------------------------------------------------
    뢮 ப.
-----------------------------------------------------------------------*/
void	pascal	PutString (int x, int y, int color, char *string)
{
  union REGS regs;

  while (*string)
  {
    movetoxy (x++, y);
    regs.h.ah = 9;
    regs.h.al = *string++;
    regs.x.cx = 1;
    regs.h.bl = color;
    regs.h.bh = 0;  /* video page 0 */
    int86 (0x10, &regs, &regs);
  }
}

/*---------------------------------------------------------------------
    뢮 ᨬ.
-----------------------------------------------------------------------*/
void	pascal	PutChar (int x, int y, int color, int c, int n)
{
  union REGS regs;

  while (n-- > 0)
  {
    movetoxy (x++, y);
    regs.h.ah = 9;
    regs.h.al = c;
    regs.x.cx = 1;
    regs.h.bl = color;
    regs.h.bh = 0;  /* video page 0 */
    int86 (0x10, &regs, &regs);
  }
}

/*---------------------------------------------------------------------
   । ⢠ ⥪⮢ ப  ᪮ (!) ࠭.
-----------------------------------------------------------------------*/
int	pascal	GetTextRows (void)
{
  union REGS regs;

  regs.h.ah = 0x0f;
  int86(0x10, &regs, &regs);
  if (regs.h.al <= 7) return 25;	// ୮  ⥪⮢ ०
					// , , Hercules.
  return *((unsigned char far *) MK_FP(0,0x484)) + 1;
/*
  regs.h.ah = 0x11;
  regs.h.al = 0x30;
  regs.h.bh = 0;
  int86(0x10, &regs, &regs);
  if (regs.h.dl >= 50) return 25;	// 室 () 訡 Fondrive.
  return (int)regs.h.dl + 1;
*/
}

/*---------------------------------------------------------------------
   । ⢠ ⥪⮢   ࠭.
-----------------------------------------------------------------------*/
int	pascal	GetTextCols (void)
{
  union REGS regs;

  regs.h.ah = 0x0f;
  int86(0x10, &regs, &regs);
  return (int)regs.h.ah;
}
#endif
#endif

