/*	disco.h

	ࠬ᪨   ᨭ⥧ ⥪⮢.

	(C) ..㫫, ..஢,   PAH, 1994 - 2000
	All Rights Reserved.
*/
#ifndef _DISCO_H
#define _DISCO_H

#ifndef _EXDEF_H
#include <exdef.h>
#endif
// =========================================================================
//	⨬ ࠭祭.
//	 ணࠬ  ࠭祭ﬨ  ४.
// =========================================================================
#ifdef __FLAT__
#define MAXBS2  3200000	// ᨬ쭠  ᠭ 奬
#define MAXBL   3200000	// ᨬ쭠  ᠭ 㭪樨
#define MAXIO   1000000	// ᨬ쭠  ᯨ᪮ 室  室
#define MAXNIO   100000	// ᨬ쭮 ⢮ 室  室
#define MAXEL    100000	// ᨬ쭮 ⢮ ⮢
#define MAXNL    200000	// ᨬ쭮 ⢮ 楯
#define MAXFIL      260	// ᨬ쭠   䠩
#else
#define MAXBS2    32000	// ᨬ쭠  ᠭ 奬
#define MAXBL     32000	// ᨬ쭠  ᠭ 㭪樨
#define MAXIO     10000	// ᨬ쭠  ᯨ᪮ 室  室
#define MAXNIO     1000	// ᨬ쭮 ⢮ 室  室
#define MAXEL      1000	// ᨬ쭮 ⢮ ⮢
#define MAXNL      2000	// ᨬ쭮 ⢮ 楯
#define MAXFIL       60	// ᨬ쭠   䠩
#endif
#define MAXNAM	 (32+1)	// ᨬ쭠   ᮢ, ⮢  楯
#define MAXTYP   (24+1)	// ᨬ쭠  ⨯   ⮬ 0
#define MAXLST   (59+1)	// ᨬ쭠  ப ⠫  ⮬ 0
#define DBPUT_LIB     9	//    ⠫ ⥪ ( ⮬ ஡)
#define DBPUT_PAR     9	//    ⠫ ࠧ  ( ⮬ ஡)

// =========================================================================
//	⠭, ⨯  .
// =========================================================================
#define	DBTABLE	0	//  饣 .
#define	DBTEXT	1	//  饣  (ப    ).
#define	DBFORM	2	//     (᫥  ).
#define	DBLIM	'\"'	// ࠭⥫   ப ⠡.
#define	DBSEP	','	// ⥫ ⮢  ப ⠡.
#define DBSPACE	' '	// ⥫   ᮮ饭  䠩 ਥ.
#define	DBSCOL	';'	// ⥫ ᮮ饭  䠩 ਥ.
#define DBCSEP  249     // ⥫ ⮩   ⠡筮 䠩.
#define DBCLIM  250     // ⥫ 窨   ⠡筮 䠩.
#define DBTEXT_START(l) (sizeof (DBGETP) + 2)		// 砫 ⥪.
#define DBTEXT_SIZE(l)	((l) - (sizeof (DBGETP) + 5))	// .⥪ (.).
#define DBCODE_SIZE(l)	((l) + (sizeof (DBGETP) + 5))	// . (.⥪).
#define	LCLIM	'\"'	// ࠭⥫   ᯨ᪥.
#define	LCSEP	','	// ⥫ ⮢  ᯨ᪥.
#define	LCSLH	'/'	// ࠭⥫ ᮢ .
#define	LCOBR	'('	// 뢠 ᪮ ᯨ᪠.
#define	LCCBR	')'	// 뢠 ᪮ ᯨ᪠.
#define	LCSCOL	';'	// ⥫ ᯨ᪮ .
#define	LCITEM_SIZE 16	// . ,  饣 ७.
#define LCLINE_SIZE 78	// . ப ᫥  ( ७).
#define LCTEXT_SIZE(l)	(((l) - sizeof (LCGETP) - 4)/2)	// .⥪ (.).
#define LCCODE_SIZE(l)	((l)*2 + sizeof (LCGETP) + 4)	// . (.⥪).

typedef	struct	{			// ࠬ ⠡ (砫 ).
	size_t	nLines;			// ᫮ ப.
	size_t	nItems;			// ᫮ .
	size_t	nFlags;			// .
}	DBGETP;
typedef struct	{			//  ⥭ ⠡.
	char	*psBuf;			//    .
	DBGETP	*psParm;		// ࠬ ⠡.
}	DBGET;
typedef struct	{			//   ⠡.
	char	*psBuf;			//    .
	char ES_*epsBuf0;		// 砫 䠩   0.
	char ES_*epsBuf;		//  .
	int	fd;			// ਯ 䠩.
}	DBPUT;

typedef	struct	{			// ࠬ ᯨ᪠ (砫 ).
	size_t	nFlags;			// .
	char	sBuf [2];		//  쭮 ࠧ.
}	LCGETP;
typedef struct	{			//  ⥭ ᯨ᪠.
	char	*psBuf;			//    .
	LCGETP	*psParm;		// ࠬ ᯨ᪠.
	int	level;			//  ஢.
	int	level0;			// 騩 ஢.
}	LCGET;
typedef struct	{			//   ᯨ᪠.
	char	*psBuf;			//    .
	char ES_*epsBuf0;		// 砫 䠩   0.
	char ES_*epsBuf;		//  .
	int	fd;			// ਯ 䠩.
	char ES_*epsLine;		//  ப (epsBuf + size_t).
	void (*pfnIndent) (void);	// ଫ 砫 ப.
}	LCPUT;

typedef	CONST char* estring;		// ⨬஢ ப.
typedef	size_t	dbpos_t;		//  ⥭ ⠡.
typedef	size_t	lcpos_t;		//  ⥭ ᯨ᪠.

#ifdef __cplusplus
extern "C" {
#endif
			  
// =========================================================================
//	⥭ /  ᯨ᪮ .
// =========================================================================
size_t	STDECL	exbread	 (const char *pszFile, char *psBuf,	// ⥭.
			  size_t lBuf, size_t mPair[][2], int nPair);
void	STDECL	exbwrite (const char *pszFile, const char *psBuf,// .
			  size_t lBuf);
void	STDECL	match	 (const char *str, size_t istr,		// .
			  size_t *istr1, size_t *istr2, size_t lstr,
			  const char *pair);
int	STDECL	arifexp	 (const char *psz);			// .

// =========================================================================
//	⥭ /  ⠡ 䠩.
// =========================================================================
//	ᮡ 㭪権 ⥭:
//	dbgetl	稭 ⥭ ࢮ  । ப  뤠 1,
//		  䠩  ⥭  ப  뤠 0.
//	dbget	뤠 㪠⥫    ।  ப,
//		  ப  ⥭  ⮢.
//	dbvalid	। ⨯ 㪠⥫: 1 =  ப, 0 = .
//		⥫ ࠧ 뢠 ᫥⥫쭮.

//	᫥⥫쭮 ⥭.				
void	EXDECL	dbget_mode	(int mode);	//  ⥭.
//	mode = DBTABLE:	⠡  ࠭祭 ᫠  (㬮砭).
//	mode = DBTEXT:	⥪ (ப   묨  ).
//	mode = DBFORM:	⠡ ࠬ஢   
//			( 2   묨  ).
//	mode = n:	⠡  ᫮    㪠
//			( n   묨  ).
//	뢠 ᫥ dbget_open  dbreadcode.
int	EXDECL	dbget_open	(const char *pszFile);
						// 砫 ⥭ 䠩.
size_t	EXDECL	dbget_nlines	(void);		// ᫮ ப   (>=0).
size_t	EXDECL	dbget_nitems	(void);		// ᫮  (>=1).
int	EXDECL	dbgetl		(void);		// । ப.
estring	EXDECL	dbget		(void);		// ।   "".
int	EXDECL	dbvalid	(const char *psz);	//  ப?
void	EXDECL	dbget_close	(void);		//  ⥭.
void	EXDECL	dbget_swap	(void);		// ४稥.

//	᫥⥫쭮 ⥭   । .
estring	EXDECL	dbgettmp	(void);		// ।   "".
void	EXDECL	dbskip		(void);		// ய .

//	⥭  ந 㯮.
dbpos_t	EXDECL	dbget_getpos	(void);		//   ⥭.
void	EXDECL	dbget_setpos	(dbpos_t pos);	// ⠭  ⥭.

//	⥫ ।  (ॠ  ࠭!).
estring	EXDECL	dbget_getnext	(void);		//  㪠⥫.
void	EXDECL	dbget_setnext (const char *psz);// ⠭ 㪠⥫. 

//	㭪樨 .
int	EXDECL	dbput_open	(const char *pszFile);
						// 砫  䠩.
void	EXDECL	dbput	(const char *psz);	//   ப.
int	EXDECL	dbputc	(int c);		//  ᨬ.
int	EXDECL	dbputce	(int c);		//   ⮩.
void	EXDECL	dbputs	(const char *psz);	//  ᨬ.
void	EXDECL 	dbputq	(const char *psz);	//    窠.
void	EXDECL	dbputl		(void);		// ॢ ப.
void	EXDECL	dbput_close	(void);		//  .
void	EXDECL	dbput_swap	(void);		// ४祭.

//	㭪樨   ᨭ⠪ᮬ ᯨ᪠.
void    EXDECL	dbput_wsub      (void);		//  '/'
void    EXDECL	dbput_wend      (void);		//  '/,'
void    EXDECL	dbput_sub       (void);		//  '('
void    EXDECL	dbput_end       (void);		//  '),'
void    EXDECL	dbput_fin       (void);		//  ';'

//	⥭/    ப.
void	EXDECL	dbgetlist   (const char **ppszList, int nList);
void	EXDECL	dbputlist   (const char **ppszList, int nList);
void	EXDECL	dbputline   (const char **ppszList, int nList);

//	⥭/ ⠡ ࠬ஢.
void	EXDECL	dbgetform   (const char **ppszForm, int nForm, int mForm);
void	EXDECL	dbputform   (const char **ppszForm, int nForm, int mForm);
void	EXDECL	dbgetputform(const char **ppszForm, int nForm, int mForm);

//	⥭/ ᮮ饭.
//	饭 -  ப,   , ஡  ⠫
//	, ࠧ ';' (,  ஡).
//	 ᮮ饭 ४ 뢠  ० DBTEXT.
//	dbdecodemsg	 ᮮ饭 ﬨ  㪠 ᫮ ;
//			 ᮮ饭   ࠧ ⮫쪮  ࠧ.
//	dbgetmsgitem	砥:
//	1)  ᮮ饭  ᪠, 稭  ᫥饩
//	   ப  NULL, ᫨ ᮮ饭 室  । ,
//	   ᫨ ॡ,  ᮮ饭  ﬨ  .
//	2)  ॡ㥬  ᮮ饭 (0=).
//	㭪樨   ⥪ .
void	EXDECL	dbdecodemsg	(int nItems);
estring	EXDECL	dbgetmsgitem	(const char *pszName, int nItem);
estring	EXDECL	dbreadmsgitem	(char *psBuf, const char *pszName, int nItem);
//	  ஡.
void	EXDECL	dbputsn	(const char *psz, int len);

//	  ᨢ.
char*	EXDECL	dbreadcode	(const char *pszFile);	//  -> .
char*	EXDECL	dbget_opencode	(char *ps);		// ⥭ .
char*	EXDECL	dbput_opentext	(char *ps, size_t len);	//  ⥪.
void	EXDECL	dbget_openstub	(void);			// ⨢ ⥭.
void	EXDECL	dbput_openstub	(void);			// ⨢ .

//	஢
char*   dbencode        (char *psz);	// ஢   祪
char*   dbdecode        (char *psz);	// ஢   祪

// =========================================================================
//	⥭ /  ᯨ᪮ 䠩.
// =========================================================================
//	ᮡ 㭪権 ⥭:
//	lcget	뤠 㪠⥫    ।  ⥪饣
//		஢   ᯨ᪠   ⢨  
//		஢  ⥭  ⮢;
//		㪠⥫ ࠧ 뢠 ᫥⥫쭮.
//	lcvalid	। ⨯ 㪠⥫: 1 = , 0 = .
//	 ⨨  ࠭ ᫮ ᯨ᪮ 1- ஢ 
//	number_sp,   㪠 0  (++)  number_sp.

//	᫥⥫쭮 ⥭ (number_sp - ᫮ ᯨ᪮  0)
void	EXDECL	lcget_mode	(int mode);	//  ⥭.
//	mode = 0:	  (㬮砭)
//	mode = 1:	  ᯨ᪮
//	mode > 1:	  ᯨ᪮   㪠 ஢
//	뢠 ᫥ lcget_open  lcreadcode.
int	EXDECL	lcget_open	(const char *pszFile, int number_sp /* =0 */);
				 		// 砫 ⥭ 䠩.				 		
estring	EXDECL	lcget		(void);		// ।   "0".
int	EXDECL	lcvalid	(const char *psz);	//  ப?
int     EXDECL	lcget_sub       (void);		// 祭 ஢  1.
int     EXDECL	lcget_end       (void);		// 襭 ஢  1.
int     EXDECL	lcget_wsub      (void);		// 祭 ஢  128.
int     EXDECL	lcget_wend      (void);		// 襭 ஢  128.
void	EXDECL	lcget_close	(void);		//  ⥭.
void	EXDECL	lcget_swap	(void);		// ४祭.

//	᫥⥫쭮 ⥭   । .
estring	EXDECL	lcgettmp	(void);		// ।   "".
void	EXDECL	lcskip		(void);		// ய .

//	᫥⥫쭮 ⥭   ⥪饣  ய饭 ⮢.
estring	EXDECL	lcgetput	(void);		//  १ lcput.
estring	EXDECL	lcgetputdb	(void);		//  १ dbput.

//	 ⮢, ய᪠  dbget.
void	EXDECL	lccopy		(void);		//  १ lcput.
void	EXDECL	lccopydb	(void);		//  १ dbput.

//	⥭  ந 㯮.
lcpos_t	EXDECL	lcget_getpos	(void);		//   ⥭.
void	EXDECL	lcget_setpos	(lcpos_t pos);	// ⠭  ⥭.

//	⥫ ।  (ॠ  ࠭!).
estring	EXDECL	lcget_getnext	(void);		//  㪠⥫.
void	EXDECL	lcget_setnext (const char *psz);// ⠭ 㪠⥫. 

//	㭪樨 .
int	EXDECL	lcput_open	(const char *pszFile);
						// 砫  䠩.
void	EXDECL	lcput	(const char *psz);	//    ⮩.
int	EXDECL	lcputc	(int c);		//  ᨬ.
int	EXDECL	lcputce	(int c);		//   ⮩.
void	EXDECL	lcputs	(const char *psz);	//  ᨬ.
void	EXDECL	lcputq	(const char *psz);	//    窠.
void    EXDECL	lcput_wsub      (void);		//  '/'
void    EXDECL	lcput_wend      (void);		//  '/,'
void    EXDECL	lcput_sub       (void);		//  '('
void    EXDECL	lcput_end       (void);		//  '),'
void	EXDECL	lcput_fin	(void);		//  ';' (易⥫쭠)
void	EXDECL	lcput_close	(void);		//  .
void	EXDECL	lcput_swap	(void);		// ४祭.

//	㭪樨 ଠ஢ ᯨ᪠.
void	EXDECL	lcput_indent	(void (*pfn) (void));
					// 㭪 㯠  NULL.
void	EXDECL	lcputl		(void);	// 筮 ॢ ப.
int	EXDECL	lcput_left	(void);	// ᫮ ᨬ.  ⮯ॢ ப.

//	  ᨢ.
char*	EXDECL	lcreadcode	(const char *pszFile,	//  -> .
				 int number_sp);	// ᫮ /  0.
char*	EXDECL	lcget_opencode	(char *ps);		// ⥭ .
char*	EXDECL	lcput_opentext	(char *ps, size_t len);	//  ⥪.
void	EXDECL	lcget_openstub	(void);			// ⨢ ⥭.
void	EXDECL	lcput_openstub	(void);			// ⨢ .

// =========================================================================
//	㦥 㭪樨   .
// =========================================================================
void	EXDECL	_dbput_check	(void);	// ⮢    ᨬ.
void	EXDECL	_dbput_chsep    (void);	// ⮢    ⮩.
void	EXDECL	_dbput_flush	(void);	//  .
void	EXDECL	_lcput_check    (void);	// ⮢    ᨬ.
void	EXDECL	_lcput_chsep    (void);	// ⮢    ⮩.
void	EXDECL	_lcput_flush	(void);	//  .
void	EXDECL	_dbdecodemsg	(void);	//   .
estring	EXDECL	dbfindmsg	(const char *pszName, int nItem, int nPos);

extern	int	VDECL	_dbget_mode;	//  ⥭ ⠡筮 䠩.
extern	DBGET	VDECL	_dbget;		//  ⥭ ⠡筮 䠩.
extern	DBPUT	VDECL	_dbput;		//   ⠡筮 䠩.
extern	int	VDECL	_lcget_mode;	//  ⥭ ᯨ᪮ 䠩.
extern	LCGET	VDECL	_lcget;		//  ⥭ ᯨ᪮ 䠩.
extern  LCPUT   VDECL	_lcput;		//   ᯨ᪮ 䠩.

#ifdef __cplusplus
}
inline	int	lcget_open (const char *pszFile)	// 砫 ⥭ 䠩.
{
  return (lcget_open (pszFile, 0));
}
#endif

// =========================================================================
//	.
// =========================================================================
#define dbget_mode(n)	( _dbget_mode = (n) )
#define	dbvalid(p)	( (p) [1] != '\n' )
#define	dbget_nlines()	( _dbget.psParm -> nLines )
#define	dbget_nitems()	( _dbget.psParm -> nItems )
#define	dbgettmp()	( dbget() )
#define dbskip()	( (void) dbget() )
#define dbget_getpos()	( (dbpos_t) _dbget.psBuf )
#define dbget_setpos(p)	( *(dbpos_t *)&_dbget.psBuf = (p) )
#define dbget_getnext()	( (estring) _dbget.psBuf )
#define dbget_setnext(p) ( dbget_setpos ( (dbpos_t) (p) ) )
#define dbdecodemsg(n)  ( _dbget_mode = (n), _dbdecodemsg() )
#define dbputc(c)	( _dbput_check(), *_dbput.psBuf++ = (char) (c) )
#define dbputq(psz)	( dbputc (DBLIM), dbput (psz),\
			  _dbput.psBuf [-1] = DBLIM, dbputc (DBSEP) )
#define dbputce(c)	( _dbput_chsep(), _dbput.psBuf [-1] = (char) (c) )
#define dbput_fin()	( dbputce (LCSCOL) )
#define	dbget_openstub	( dbget_opencode (NULL) )
#define	dbput_openstub	( dbput_opentext (NULL, 0) )
#define lcget_mode(n)	( _lcget_mode = (n) )
#define	lcvalid(p)	( AX = *(unsigned short *)(p),\
			  AL || AH >= (unsigned char)_lcget.level )
#define lcgettmp()	( lcget() )
#define lcskip()	( (void) lcget() )
#define	lcgetput()	( lcput (_lcget.psBuf), lccopy(),   lcget() )
#define	lcgetputdb()	( dbput (_lcget.psBuf), lccopydb(), lcget() )
#define lcget_getpos()	( (lcpos_t) _lcget.psBuf )
#define lcget_setpos(p) ( _lcget.level0 = _lcget.level,\
			  *(lcpos_t *)&_lcget.psBuf = (p) )
#define lcget_setnext(p) ( lcget_setpos ( (lcpos_t) (p) - 2 ) )
#define lcget_sub()     ( ++_lcget.level )
#define lcget_end()     ( --_lcget.level )
#define lcget_wsub()    ( _lcget.level += 128 )
#define lcget_wend()    ( _lcget.level -= 128 )
#define	lcput_indent(p) ( _lcput.pfnIndent = (p) )
#define	lcput_left()	( (int) (_lcput.epsLine - (char ES_*)_lcput.psBuf) )
#define lcputc(c)	( _lcput_check(), *_lcput.psBuf++ = (char) (c) )
#define lcputq(psz)	( lcputc (DBLIM), lcput (psz),\
			  _lcput.psBuf [-1] = LCLIM, lcputc (LCSEP) )
#define lcputce(c)	( _lcput_chsep(), _lcput.psBuf [-1] = (char) (c) )
#define lcput_fin()	( lcputce (LCSCOL), lcputl() )
#define	lcget_openstub	( lcget_opencode (NULL) )
#define	lcput_openstub	( lcput_opentext (NULL, 0) )

#ifdef USE_SCAN
// =========================================================================
//	ॢ訥 㭪樨. ᯮ짮:
//	  #define USE_SCAN
//	  #include <disco.h>
// =========================================================================
#ifdef __cplusplus
extern "C" {
#endif
char*	EXDECL	dbscanl		(void);		// 1 - . ப  NULL. 
char*	EXDECL	dbscan		(void);		// ।   NULL.
char*	EXDECL	lcscan		(void);		// ।   NULL.
char*   EXDECL	lcscanput	(void);		// ।   NULL.
char*   EXDECL	lcscanputdb	(void);		// ।   NULL.
char*	EXDECL	dbget_posptr	(dbpos_t pos);	//  -> 㪠⥫.
dbpos_t	EXDECL	dbget_ptrpos	(char *psz);	// ⥫ -> .
char*	EXDECL	lcget_posptr	(lcpos_t pos);	//  -> 㪠⥫.
lcpos_t	EXDECL	lcget_ptrpos	(char *psz);	// ⥫ -> .
#ifdef __cplusplus
}
#endif
#define dbscanl()	( dbgetl()? _dbget.psBuf: NULL )
#define	dbscan()	( dbvalid (_dbget.psBuf)? dbget(): NULL )
#define	lcscan()	( lcvalid (lcget())?	  _lcget.psBuf: NULL )
#define	lcscanput()	( lcvalid (lcgetput())?   _lcget.psBuf: NULL )
#define	lcscanputdb()	( lcvalid (lcgetputdb())? _lcget.psBuf: NULL )
#define	dbget_posptr(p)	( ESCONS (_dbget.psBuf,	(char ES_*) (p) ) )
#define	dbget_ptrpos(p)	( (dbpos_t) (p) )
#define	lcget_posptr(p)	( ESCONS (_lcget.psBuf,	(char ES_*) (p) ) )
#define	lcget_ptrpos(p)	( (lcpos_t) (p) )
#endif

#endif//_DISCO_H
